/* krcfile.c generated by valac 0.56.17, the Vala compiler
 * generated from krcfile.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2024 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <limits.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_KRC_FILE_KEY_VALUE_PAIR (krc_file_key_value_pair_get_type ())
typedef struct _KRcFileKeyValuePair KRcFileKeyValuePair;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_KRC_FILE_GROUP (krc_file_group_get_type ())
typedef struct _KRcFileGroup KRcFileGroup;

#define TYPE_KRC_FILE (krc_file_get_type ())
#define KRC_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KRC_FILE, KRcFile))
#define KRC_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KRC_FILE, KRcFileClass))
#define IS_KRC_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KRC_FILE))
#define IS_KRC_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KRC_FILE))
#define KRC_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KRC_FILE, KRcFileClass))

typedef struct _KRcFile KRcFile;
typedef struct _KRcFileClass KRcFileClass;
typedef struct _KRcFilePrivate KRcFilePrivate;
#define _krc_file_group_free0(var) ((var == NULL) ? NULL : (var = (krc_file_group_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _krc_file_key_value_pair_free0(var) ((var == NULL) ? NULL : (var = (krc_file_key_value_pair_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ParamSpecKRcFile ParamSpecKRcFile;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KRcFileKeyValuePair {
	gchar* key;
	gchar* value;
};

struct _KRcFileGroup {
	gchar* name;
	GList* key_value_pairs;
};

struct _KRcFile {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KRcFilePrivate * priv;
};

struct _KRcFileClass {
	GTypeClass parent_class;
	void (*finalize) (KRcFile *self);
};

struct _KRcFilePrivate {
	KRcFileGroup* m_current_group;
	GList* m_groups;
};

struct _ParamSpecKRcFile {
	GParamSpec parent_instance;
};

static gint KRcFile_private_offset;
static gpointer krc_file_parent_class = NULL;

VALA_EXTERN GType krc_file_key_value_pair_get_type (void) G_GNUC_CONST ;
VALA_EXTERN KRcFileKeyValuePair* krc_file_key_value_pair_dup (const KRcFileKeyValuePair* self);
VALA_EXTERN void krc_file_key_value_pair_free (KRcFileKeyValuePair* self);
VALA_EXTERN void krc_file_key_value_pair_copy (const KRcFileKeyValuePair* self,
                                   KRcFileKeyValuePair* dest);
VALA_EXTERN void krc_file_key_value_pair_destroy (KRcFileKeyValuePair* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (KRcFileKeyValuePair, krc_file_key_value_pair_destroy)
VALA_EXTERN GType krc_file_group_get_type (void) G_GNUC_CONST ;
VALA_EXTERN KRcFileGroup* krc_file_group_dup (const KRcFileGroup* self);
VALA_EXTERN void krc_file_group_free (KRcFileGroup* self);
VALA_EXTERN void krc_file_group_copy (const KRcFileGroup* self,
                          KRcFileGroup* dest);
VALA_EXTERN void krc_file_group_destroy (KRcFileGroup* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (KRcFileGroup, krc_file_group_destroy)
VALA_EXTERN gpointer krc_file_ref (gpointer instance);
VALA_EXTERN void krc_file_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_krc_file (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
VALA_EXTERN void value_set_krc_file (GValue* value,
                         gpointer v_object);
VALA_EXTERN void value_take_krc_file (GValue* value,
                          gpointer v_object);
VALA_EXTERN gpointer value_get_krc_file (const GValue* value);
VALA_EXTERN GType krc_file_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KRcFile, krc_file_unref)
static void _krc_file_group_free0_ (gpointer var);
static inline void _g_list_free__krc_file_group_free0_ (GList* self);
VALA_EXTERN KRcFile* krc_file_new (void);
VALA_EXTERN KRcFile* krc_file_construct (GType object_type);
static gboolean krc_file_is_comment (KRcFile* self,
                              const gchar* line);
static gboolean krc_file_is_group (KRcFile* self,
                            const gchar* line);
static gboolean krc_file_is_group_name (KRcFile* self,
                                 const gchar* name);
static gboolean krc_file_is_key_value_pair (KRcFile* self,
                                     const gchar* line);
static gboolean krc_file_is_key_name (KRcFile* self,
                               const gchar* line,
                               gsize length);
static gint krc_file_find_group (KRcFileGroup* group1,
                          KRcFileGroup* group2);
static GList* krc_file_get_group_node_with_name (KRcFile* self,
                                          const gchar* group_name,
                                          gboolean if_throw_error,
                                          GError** error);
static void krc_file_add_key_value_pair (KRcFile* self,
                                  KRcFileGroup* group,
                                  KRcFileKeyValuePair* pair,
                                  GList* sibling);
static void krc_file_add_key (KRcFile* self,
                       KRcFileGroup* group,
                       const gchar* key,
                       const gchar* value);
static void krc_file_parse_comment (KRcFile* self,
                             const gchar* line,
                             glong length);
static void krc_file_parse_group (KRcFile* self,
                           const gchar* line,
                           glong length,
                           GError** error);
static void krc_file_parse_key_value_pair (KRcFile* self,
                                    const gchar* line,
                                    glong length,
                                    GError** error);
static void krc_file_parse_line (KRcFile* self,
                          const gchar* line,
                          glong length,
                          GError** error);
static gboolean krc_file_parse_data (KRcFile* self,
                              const gchar* data,
                              gsize length);
VALA_EXTERN gboolean krc_file_load_from_file (KRcFile* self,
                                  const gchar* path,
                                  GKeyFileFlags flags,
                                  GError** error);
VALA_EXTERN gboolean krc_file_has_group (KRcFile* self,
                             const gchar* group_name);
VALA_EXTERN gchar** krc_file_get_keys (KRcFile* self,
                           const gchar* group_name,
                           gint* result_length1,
                           GError** error);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gboolean krc_file_has_key (KRcFile* self,
                           const gchar* group_name,
                           const gchar* key,
                           GError** error);
VALA_EXTERN gboolean krc_file_remove_group (KRcFile* self,
                                const gchar* group_name,
                                GError** error);
VALA_EXTERN gboolean krc_file_remove_key (KRcFile* self,
                              const gchar* group_name,
                              const gchar* key,
                              GError** error);
VALA_EXTERN gchar* krc_file_to_data (KRcFile* self,
                         gssize* length);
VALA_EXTERN gboolean krc_file_save_to_file (KRcFile* self,
                                const gchar* filename,
                                GError** error);
VALA_EXTERN gchar* krc_file_get_value (KRcFile* self,
                           const gchar* group_name,
                           const gchar* key,
                           GError** error);
VALA_EXTERN void krc_file_set_value (KRcFile* self,
                         const gchar* group_name,
                         const gchar* key,
                         const gchar* value);
static void krc_file_finalize (KRcFile * obj);
static GType krc_file_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
krc_file_key_value_pair_copy (const KRcFileKeyValuePair* self,
                              KRcFileKeyValuePair* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 23 "krcfile.vala"
	_tmp0_ = (*self).key;
#line 23 "krcfile.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 23 "krcfile.vala"
	_g_free0 ((*dest).key);
#line 23 "krcfile.vala"
	(*dest).key = _tmp1_;
#line 23 "krcfile.vala"
	_tmp2_ = (*self).value;
#line 23 "krcfile.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 23 "krcfile.vala"
	_g_free0 ((*dest).value);
#line 23 "krcfile.vala"
	(*dest).value = _tmp3_;
#line 259 "krcfile.c"
}

void
krc_file_key_value_pair_destroy (KRcFileKeyValuePair* self)
{
#line 24 "krcfile.vala"
	_g_free0 ((*self).key);
#line 25 "krcfile.vala"
	_g_free0 ((*self).value);
#line 269 "krcfile.c"
}

KRcFileKeyValuePair*
krc_file_key_value_pair_dup (const KRcFileKeyValuePair* self)
{
	KRcFileKeyValuePair* dup;
#line 23 "krcfile.vala"
	dup = g_new0 (KRcFileKeyValuePair, 1);
#line 23 "krcfile.vala"
	krc_file_key_value_pair_copy (self, dup);
#line 23 "krcfile.vala"
	return dup;
#line 282 "krcfile.c"
}

void
krc_file_key_value_pair_free (KRcFileKeyValuePair* self)
{
#line 23 "krcfile.vala"
	krc_file_key_value_pair_destroy (self);
#line 23 "krcfile.vala"
	g_free (self);
#line 292 "krcfile.c"
}

static GType
krc_file_key_value_pair_get_type_once (void)
{
	GType krc_file_key_value_pair_type_id;
	krc_file_key_value_pair_type_id = g_boxed_type_register_static ("KRcFileKeyValuePair", (GBoxedCopyFunc) krc_file_key_value_pair_dup, (GBoxedFreeFunc) krc_file_key_value_pair_free);
	return krc_file_key_value_pair_type_id;
}

GType
krc_file_key_value_pair_get_type (void)
{
	static volatile gsize krc_file_key_value_pair_type_id__once = 0;
	if (g_once_init_enter (&krc_file_key_value_pair_type_id__once)) {
		GType krc_file_key_value_pair_type_id;
		krc_file_key_value_pair_type_id = krc_file_key_value_pair_get_type_once ();
		g_once_init_leave (&krc_file_key_value_pair_type_id__once, krc_file_key_value_pair_type_id);
	}
	return krc_file_key_value_pair_type_id__once;
}

void
krc_file_group_copy (const KRcFileGroup* self,
                     KRcFileGroup* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GList* _tmp2_;
#line 28 "krcfile.vala"
	_tmp0_ = (*self).name;
#line 28 "krcfile.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 28 "krcfile.vala"
	_g_free0 ((*dest).name);
#line 28 "krcfile.vala"
	(*dest).name = _tmp1_;
#line 28 "krcfile.vala"
	_tmp2_ = (*self).key_value_pairs;
#line 28 "krcfile.vala"
	(*dest).key_value_pairs = _tmp2_;
#line 334 "krcfile.c"
}

void
krc_file_group_destroy (KRcFileGroup* self)
{
#line 29 "krcfile.vala"
	_g_free0 ((*self).name);
#line 342 "krcfile.c"
}

KRcFileGroup*
krc_file_group_dup (const KRcFileGroup* self)
{
	KRcFileGroup* dup;
#line 28 "krcfile.vala"
	dup = g_new0 (KRcFileGroup, 1);
#line 28 "krcfile.vala"
	krc_file_group_copy (self, dup);
#line 28 "krcfile.vala"
	return dup;
#line 355 "krcfile.c"
}

void
krc_file_group_free (KRcFileGroup* self)
{
#line 28 "krcfile.vala"
	krc_file_group_destroy (self);
#line 28 "krcfile.vala"
	g_free (self);
#line 365 "krcfile.c"
}

static GType
krc_file_group_get_type_once (void)
{
	GType krc_file_group_type_id;
	krc_file_group_type_id = g_boxed_type_register_static ("KRcFileGroup", (GBoxedCopyFunc) krc_file_group_dup, (GBoxedFreeFunc) krc_file_group_free);
	return krc_file_group_type_id;
}

GType
krc_file_group_get_type (void)
{
	static volatile gsize krc_file_group_type_id__once = 0;
	if (g_once_init_enter (&krc_file_group_type_id__once)) {
		GType krc_file_group_type_id;
		krc_file_group_type_id = krc_file_group_get_type_once ();
		g_once_init_leave (&krc_file_group_type_id__once, krc_file_group_type_id);
	}
	return krc_file_group_type_id__once;
}

static inline gpointer
krc_file_get_instance_private (KRcFile* self)
{
	return G_STRUCT_MEMBER_P (self, KRcFile_private_offset);
}

static void
_krc_file_group_free0_ (gpointer var)
{
#line 36 "krcfile.vala"
	(var == NULL) ? NULL : (var = (krc_file_group_free (var), NULL));
#line 399 "krcfile.c"
}

static inline void
_g_list_free__krc_file_group_free0_ (GList* self)
{
#line 36 "krcfile.vala"
	g_list_free_full (self, (GDestroyNotify) _krc_file_group_free0_);
#line 407 "krcfile.c"
}

static gpointer
_krc_file_group_dup0 (gpointer self)
{
#line 39 "krcfile.vala"
	return self ? krc_file_group_dup (self) : NULL;
#line 415 "krcfile.c"
}

KRcFile*
krc_file_construct (GType object_type)
{
	KRcFile* self = NULL;
	KRcFileGroup* group = NULL;
	KRcFileGroup _tmp0_ = {0};
	KRcFileGroup _tmp1_;
	KRcFileGroup* _tmp2_;
	KRcFileGroup* _tmp3_;
	KRcFileGroup* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
#line 38 "krcfile.vala"
	self = (KRcFile*) g_type_create_instance (object_type);
#line 39 "krcfile.vala"
	memset (&_tmp0_, 0, sizeof (KRcFileGroup));
#line 39 "krcfile.vala"
	_tmp1_ = _tmp0_;
#line 39 "krcfile.vala"
	_tmp2_ = _krc_file_group_dup0 (&_tmp1_);
#line 39 "krcfile.vala"
	_tmp3_ = _tmp2_;
#line 39 "krcfile.vala"
	krc_file_group_destroy (&_tmp1_);
#line 39 "krcfile.vala"
	group = _tmp3_;
#line 40 "krcfile.vala"
	_tmp4_ = _krc_file_group_dup0 (group);
#line 40 "krcfile.vala"
	self->priv->m_groups = g_list_prepend (self->priv->m_groups, _tmp4_);
#line 43 "krcfile.vala"
	_tmp5_ = self->priv->m_groups;
#line 43 "krcfile.vala"
	_tmp6_ = _tmp5_->data;
#line 43 "krcfile.vala"
	self->priv->m_current_group = (KRcFileGroup*) ((KRcFileGroup*) _tmp6_);
#line 38 "krcfile.vala"
	_krc_file_group_free0 (group);
#line 38 "krcfile.vala"
	return self;
#line 458 "krcfile.c"
}

KRcFile*
krc_file_new (void)
{
#line 38 "krcfile.vala"
	return krc_file_construct (TYPE_KRC_FILE);
#line 466 "krcfile.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 480 "krcfile.c"
}

static gboolean
krc_file_is_comment (KRcFile* self,
                     const gchar* line)
{
	gunichar ch = 0U;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 46 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "krcfile.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 47 "krcfile.vala"
	ch = string_get_char (line, (glong) 0);
#line 48 "krcfile.vala"
	if (ch == ((gunichar) '#')) {
#line 48 "krcfile.vala"
		_tmp1_ = TRUE;
#line 501 "krcfile.c"
	} else {
#line 48 "krcfile.vala"
		_tmp1_ = ch == ((gunichar) '\0');
#line 505 "krcfile.c"
	}
#line 48 "krcfile.vala"
	if (_tmp1_) {
#line 48 "krcfile.vala"
		_tmp0_ = TRUE;
#line 511 "krcfile.c"
	} else {
#line 48 "krcfile.vala"
		_tmp0_ = ch == ((gunichar) '\n');
#line 515 "krcfile.c"
	}
#line 48 "krcfile.vala"
	result = _tmp0_;
#line 48 "krcfile.vala"
	return result;
#line 521 "krcfile.c"
}

static gboolean
krc_file_is_group (KRcFile* self,
                   const gchar* line)
{
	gint i = 0;
	gint length = 0;
	gboolean result;
#line 51 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "krcfile.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 52 "krcfile.vala"
	if (string_get_char (line, (glong) 0) != ((gunichar) '[')) {
#line 53 "krcfile.vala"
		result = FALSE;
#line 53 "krcfile.vala"
		return result;
#line 541 "krcfile.c"
	}
#line 54 "krcfile.vala"
	i = 1;
#line 55 "krcfile.vala"
	length = g_utf8_strlen (line, (gssize) -1);
#line 56 "krcfile.vala"
	while (TRUE) {
#line 549 "krcfile.c"
		gunichar ch = 0U;
		gint _tmp0_;
#line 56 "krcfile.vala"
		if (!(i < length)) {
#line 56 "krcfile.vala"
			break;
#line 556 "krcfile.c"
		}
#line 57 "krcfile.vala"
		ch = string_get_char (line, (glong) i);
#line 58 "krcfile.vala"
		if (ch == ((gunichar) ']')) {
#line 59 "krcfile.vala"
			result = TRUE;
#line 59 "krcfile.vala"
			return result;
#line 566 "krcfile.c"
		}
#line 60 "krcfile.vala"
		_tmp0_ = i;
#line 60 "krcfile.vala"
		i = _tmp0_ + 1;
#line 572 "krcfile.c"
	}
#line 62 "krcfile.vala"
	result = FALSE;
#line 62 "krcfile.vala"
	return result;
#line 578 "krcfile.c"
}

static gboolean
krc_file_is_group_name (KRcFile* self,
                        const gchar* name)
{
	gint i = 0;
	gint length = 0;
	gunichar ch = 0U;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 66 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 66 "krcfile.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 67 "krcfile.vala"
	i = 0;
#line 68 "krcfile.vala"
	length = g_utf8_strlen (name, (gssize) -1);
#line 69 "krcfile.vala"
	ch = (gunichar) 0;
#line 70 "krcfile.vala"
	while (TRUE) {
#line 602 "krcfile.c"
		gboolean _tmp0_ = FALSE;
		gint _tmp1_;
#line 70 "krcfile.vala"
		if (!(i < length)) {
#line 70 "krcfile.vala"
			break;
#line 609 "krcfile.c"
		}
#line 71 "krcfile.vala"
		ch = string_get_char (name, (glong) i);
#line 72 "krcfile.vala"
		if (ch == ((gunichar) '\0')) {
#line 72 "krcfile.vala"
			_tmp0_ = TRUE;
#line 617 "krcfile.c"
		} else {
#line 72 "krcfile.vala"
			_tmp0_ = g_unichar_iscntrl (ch);
#line 621 "krcfile.c"
		}
#line 72 "krcfile.vala"
		if (_tmp0_) {
#line 73 "krcfile.vala"
			break;
#line 627 "krcfile.c"
		}
#line 74 "krcfile.vala"
		_tmp1_ = i;
#line 74 "krcfile.vala"
		i = _tmp1_ + 1;
#line 633 "krcfile.c"
	}
#line 76 "krcfile.vala"
	if (i != 0) {
#line 637 "krcfile.c"
		gboolean _tmp3_ = FALSE;
#line 76 "krcfile.vala"
		if (i == length) {
#line 76 "krcfile.vala"
			_tmp3_ = TRUE;
#line 643 "krcfile.c"
		} else {
#line 76 "krcfile.vala"
			_tmp3_ = ch == ((gunichar) '\0');
#line 647 "krcfile.c"
		}
#line 76 "krcfile.vala"
		_tmp2_ = _tmp3_;
#line 651 "krcfile.c"
	} else {
#line 76 "krcfile.vala"
		_tmp2_ = FALSE;
#line 655 "krcfile.c"
	}
#line 76 "krcfile.vala"
	if (_tmp2_) {
#line 77 "krcfile.vala"
		result = TRUE;
#line 77 "krcfile.vala"
		return result;
#line 663 "krcfile.c"
	}
#line 78 "krcfile.vala"
	result = FALSE;
#line 78 "krcfile.vala"
	return result;
#line 669 "krcfile.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1204 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1205 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1205 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1207 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1207 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 691 "krcfile.c"
		gchar* _tmp2_;
#line 1208 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1208 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1208 "glib-2.0.vapi"
		return result;
#line 699 "krcfile.c"
	} else {
#line 1210 "glib-2.0.vapi"
		result = -1;
#line 1210 "glib-2.0.vapi"
		return result;
#line 705 "krcfile.c"
	}
}

static gboolean
krc_file_is_key_value_pair (KRcFile* self,
                            const gchar* line)
{
	gint pos = 0;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 81 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "krcfile.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 82 "krcfile.vala"
	pos = string_index_of_char (line, (gunichar) '=', 0);
#line 83 "krcfile.vala"
	if (pos == -1) {
#line 83 "krcfile.vala"
		_tmp0_ = TRUE;
#line 726 "krcfile.c"
	} else {
#line 83 "krcfile.vala"
		_tmp0_ = pos == 0;
#line 730 "krcfile.c"
	}
#line 83 "krcfile.vala"
	if (_tmp0_) {
#line 84 "krcfile.vala"
		result = FALSE;
#line 84 "krcfile.vala"
		return result;
#line 738 "krcfile.c"
	}
#line 85 "krcfile.vala"
	result = TRUE;
#line 85 "krcfile.vala"
	return result;
#line 744 "krcfile.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 761 "krcfile.c"
}

static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1322 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1323 "glib-2.0.vapi"
	return result;
#line 775 "krcfile.c"
}

static gboolean
krc_file_is_key_name (KRcFile* self,
                      const gchar* line,
                      gsize length)
{
	glong i = 0L;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 89 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "krcfile.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 90 "krcfile.vala"
	i = (glong) 0;
#line 92 "krcfile.vala"
	_vala_assert (length < ((gsize) SSIZE_MAX), "length < Posix.Limits.SSIZE_MAX");
#line 93 "krcfile.vala"
	while (TRUE) {
#line 797 "krcfile.c"
		gchar ch = '\0';
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		glong _tmp2_;
#line 93 "krcfile.vala"
		if (!(((gsize) i) < length)) {
#line 93 "krcfile.vala"
			break;
#line 806 "krcfile.c"
		}
#line 94 "krcfile.vala"
		ch = string_get (line, i);
#line 95 "krcfile.vala"
		if (ch == '=') {
#line 95 "krcfile.vala"
			_tmp1_ = TRUE;
#line 814 "krcfile.c"
		} else {
#line 95 "krcfile.vala"
			_tmp1_ = ch == '[';
#line 818 "krcfile.c"
		}
#line 95 "krcfile.vala"
		if (_tmp1_) {
#line 95 "krcfile.vala"
			_tmp0_ = TRUE;
#line 824 "krcfile.c"
		} else {
#line 95 "krcfile.vala"
			_tmp0_ = ch == ']';
#line 828 "krcfile.c"
		}
#line 95 "krcfile.vala"
		if (_tmp0_) {
#line 96 "krcfile.vala"
			break;
#line 834 "krcfile.c"
		}
#line 97 "krcfile.vala"
		if (ch == '\0') {
#line 98 "krcfile.vala"
			i = (glong) length;
#line 99 "krcfile.vala"
			break;
#line 842 "krcfile.c"
		}
#line 101 "krcfile.vala"
		_tmp2_ = i;
#line 101 "krcfile.vala"
		i = _tmp2_ + 1;
#line 848 "krcfile.c"
	}
#line 103 "krcfile.vala"
	if (i == ((glong) 0)) {
#line 104 "krcfile.vala"
		result = FALSE;
#line 104 "krcfile.vala"
		return result;
#line 856 "krcfile.c"
	}
#line 105 "krcfile.vala"
	if (string_get (line, (glong) 0) == ' ') {
#line 105 "krcfile.vala"
		_tmp3_ = TRUE;
#line 862 "krcfile.c"
	} else {
#line 105 "krcfile.vala"
		_tmp3_ = string_get (line, i - 1) == ' ';
#line 866 "krcfile.c"
	}
#line 105 "krcfile.vala"
	if (_tmp3_) {
#line 106 "krcfile.vala"
		result = FALSE;
#line 106 "krcfile.vala"
		return result;
#line 874 "krcfile.c"
	}
#line 107 "krcfile.vala"
	if (((gsize) i) < length) {
#line 107 "krcfile.vala"
		_tmp4_ = string_get (line, i) == '[';
#line 880 "krcfile.c"
	} else {
#line 107 "krcfile.vala"
		_tmp4_ = FALSE;
#line 884 "krcfile.c"
	}
#line 107 "krcfile.vala"
	if (_tmp4_) {
#line 888 "krcfile.c"
		glong _tmp5_;
		glong _tmp13_;
#line 108 "krcfile.vala"
		_tmp5_ = i;
#line 108 "krcfile.vala"
		i = _tmp5_ + 1;
#line 109 "krcfile.vala"
		while (TRUE) {
#line 897 "krcfile.c"
			gunichar ch = 0U;
			const gchar* _tmp6_;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			glong _tmp12_;
#line 109 "krcfile.vala"
			if (!(((gsize) i) < length)) {
#line 109 "krcfile.vala"
				break;
#line 910 "krcfile.c"
			}
#line 110 "krcfile.vala"
			_vala_assert (((gsize) SSIZE_MAX) > (length - i), "Posix.Limits.SSIZE_MAX > length - i");
#line 111 "krcfile.vala"
			_tmp6_ = string_offset (line, i);
#line 111 "krcfile.vala"
			ch = g_utf8_get_char_validated (_tmp6_, ((gssize) length) - i);
#line 113 "krcfile.vala"
			if (ch <= ((gunichar) 0)) {
#line 114 "krcfile.vala"
				break;
#line 922 "krcfile.c"
			}
#line 116 "krcfile.vala"
			if (!g_unichar_isalnum (ch)) {
#line 116 "krcfile.vala"
				_tmp11_ = ch != ((gunichar) '-');
#line 928 "krcfile.c"
			} else {
#line 116 "krcfile.vala"
				_tmp11_ = FALSE;
#line 932 "krcfile.c"
			}
#line 116 "krcfile.vala"
			if (_tmp11_) {
#line 116 "krcfile.vala"
				_tmp10_ = ch != ((gunichar) '_');
#line 938 "krcfile.c"
			} else {
#line 116 "krcfile.vala"
				_tmp10_ = FALSE;
#line 942 "krcfile.c"
			}
#line 116 "krcfile.vala"
			if (_tmp10_) {
#line 116 "krcfile.vala"
				_tmp9_ = ch != ((gunichar) '.');
#line 948 "krcfile.c"
			} else {
#line 116 "krcfile.vala"
				_tmp9_ = FALSE;
#line 952 "krcfile.c"
			}
#line 116 "krcfile.vala"
			if (_tmp9_) {
#line 117 "krcfile.vala"
				_tmp8_ = ch != ((gunichar) '@');
#line 958 "krcfile.c"
			} else {
#line 116 "krcfile.vala"
				_tmp8_ = FALSE;
#line 962 "krcfile.c"
			}
#line 116 "krcfile.vala"
			if (_tmp8_) {
#line 117 "krcfile.vala"
				_tmp7_ = ch != ((gunichar) '$');
#line 968 "krcfile.c"
			} else {
#line 116 "krcfile.vala"
				_tmp7_ = FALSE;
#line 972 "krcfile.c"
			}
#line 116 "krcfile.vala"
			if (_tmp7_) {
#line 118 "krcfile.vala"
				break;
#line 978 "krcfile.c"
			}
#line 120 "krcfile.vala"
			_tmp12_ = i;
#line 120 "krcfile.vala"
			i = _tmp12_ + 1;
#line 984 "krcfile.c"
		}
#line 122 "krcfile.vala"
		if (((gsize) i) == length) {
#line 123 "krcfile.vala"
			result = FALSE;
#line 123 "krcfile.vala"
			return result;
#line 992 "krcfile.c"
		}
#line 124 "krcfile.vala"
		if (string_get (line, i) != ']') {
#line 125 "krcfile.vala"
			result = FALSE;
#line 125 "krcfile.vala"
			return result;
#line 1000 "krcfile.c"
		}
#line 127 "krcfile.vala"
		_tmp13_ = i;
#line 127 "krcfile.vala"
		i = _tmp13_ + 1;
#line 1006 "krcfile.c"
	}
#line 129 "krcfile.vala"
	if (((gsize) i) < length) {
#line 130 "krcfile.vala"
		result = FALSE;
#line 130 "krcfile.vala"
		return result;
#line 1014 "krcfile.c"
	}
#line 131 "krcfile.vala"
	result = TRUE;
#line 131 "krcfile.vala"
	return result;
#line 1020 "krcfile.c"
}

static gint
krc_file_find_group (KRcFileGroup* group1,
                     KRcFileGroup* group2)
{
	KRcFileGroup _tmp0_;
	const gchar* _tmp1_;
	KRcFileGroup _tmp4_;
	const gchar* _tmp5_;
	KRcFileGroup _tmp6_;
	const gchar* _tmp7_;
	KRcFileGroup _tmp8_;
	const gchar* _tmp9_;
	gint result;
#line 134 "krcfile.vala"
	g_return_val_if_fail (group1 != NULL, 0);
#line 134 "krcfile.vala"
	g_return_val_if_fail (group2 != NULL, 0);
#line 135 "krcfile.vala"
	_tmp0_ = *group1;
#line 135 "krcfile.vala"
	_tmp1_ = _tmp0_.name;
#line 135 "krcfile.vala"
	if (_tmp1_ == NULL) {
#line 1046 "krcfile.c"
		KRcFileGroup _tmp2_;
		const gchar* _tmp3_;
#line 136 "krcfile.vala"
		_tmp2_ = *group2;
#line 136 "krcfile.vala"
		_tmp3_ = _tmp2_.name;
#line 136 "krcfile.vala"
		if (_tmp3_ == NULL) {
#line 137 "krcfile.vala"
			result = 0;
#line 137 "krcfile.vala"
			return result;
#line 1059 "krcfile.c"
		}
#line 138 "krcfile.vala"
		result = -1;
#line 138 "krcfile.vala"
		return result;
#line 1065 "krcfile.c"
	}
#line 140 "krcfile.vala"
	_tmp4_ = *group2;
#line 140 "krcfile.vala"
	_tmp5_ = _tmp4_.name;
#line 140 "krcfile.vala"
	if (_tmp5_ == NULL) {
#line 141 "krcfile.vala"
		result = 1;
#line 141 "krcfile.vala"
		return result;
#line 1077 "krcfile.c"
	}
#line 142 "krcfile.vala"
	_tmp6_ = *group1;
#line 142 "krcfile.vala"
	_tmp7_ = _tmp6_.name;
#line 142 "krcfile.vala"
	_tmp8_ = *group2;
#line 142 "krcfile.vala"
	_tmp9_ = _tmp8_.name;
#line 142 "krcfile.vala"
	result = g_ascii_strcasecmp (_tmp7_, _tmp9_);
#line 142 "krcfile.vala"
	return result;
#line 1091 "krcfile.c"
}

static GList*
krc_file_get_group_node_with_name (KRcFile* self,
                                   const gchar* group_name,
                                   gboolean if_throw_error,
                                   GError** error)
{
	KRcFileGroup tmp = {0};
	gchar* _tmp0_;
	GList* group_node = NULL;
	GList* _tmp1_;
	KRcFileGroup _tmp2_;
	GList* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GList* _tmp5_;
	GList* _tmp7_;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 145 "krcfile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "krcfile.vala"
	g_return_val_if_fail (group_name != NULL, NULL);
#line 149 "krcfile.vala"
	memset (&tmp, 0, sizeof (KRcFileGroup));
#line 150 "krcfile.vala"
	_tmp0_ = g_strdup (group_name);
#line 150 "krcfile.vala"
	_g_free0 (tmp.name);
#line 150 "krcfile.vala"
	tmp.name = _tmp0_;
#line 151 "krcfile.vala"
	_tmp1_ = self->priv->m_groups;
#line 151 "krcfile.vala"
	_tmp2_ = tmp;
#line 151 "krcfile.vala"
	_tmp3_ = g_list_find_custom (_tmp1_, &_tmp2_, (GCompareFunc) krc_file_find_group);
#line 151 "krcfile.vala"
	group_node = _tmp3_;
#line 154 "krcfile.vala"
	_tmp5_ = group_node;
#line 154 "krcfile.vala"
	if (_tmp5_ == NULL) {
#line 154 "krcfile.vala"
		_tmp4_ = if_throw_error;
#line 1137 "krcfile.c"
	} else {
#line 154 "krcfile.vala"
		_tmp4_ = FALSE;
#line 1141 "krcfile.c"
	}
#line 154 "krcfile.vala"
	if (_tmp4_) {
#line 1145 "krcfile.c"
		GError* _tmp6_;
#line 155 "krcfile.vala"
		_tmp6_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND, "Key file does not have group %s", group_name);
#line 155 "krcfile.vala"
		_inner_error0_ = _tmp6_;
#line 155 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 155 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 155 "krcfile.vala"
			krc_file_group_destroy (&tmp);
#line 155 "krcfile.vala"
			return NULL;
#line 1159 "krcfile.c"
		} else {
#line 155 "krcfile.vala"
			krc_file_group_destroy (&tmp);
#line 155 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 155 "krcfile.vala"
			return NULL;
#line 1169 "krcfile.c"
		}
	}
#line 158 "krcfile.vala"
	_tmp7_ = group_node;
#line 158 "krcfile.vala"
	result = _tmp7_;
#line 158 "krcfile.vala"
	krc_file_group_destroy (&tmp);
#line 158 "krcfile.vala"
	return result;
#line 1180 "krcfile.c"
}

static gpointer
_krc_file_key_value_pair_dup0 (gpointer self)
{
#line 164 "krcfile.vala"
	return self ? krc_file_key_value_pair_dup (self) : NULL;
#line 1188 "krcfile.c"
}

static void
krc_file_add_key_value_pair (KRcFile* self,
                             KRcFileGroup* group,
                             KRcFileKeyValuePair* pair,
                             GList* sibling)
{
	KRcFileKeyValuePair _tmp0_;
	KRcFileKeyValuePair _tmp1_;
	KRcFileKeyValuePair* _tmp2_;
#line 161 "krcfile.vala"
	g_return_if_fail (self != NULL);
#line 161 "krcfile.vala"
	g_return_if_fail (pair != NULL);
#line 164 "krcfile.vala"
	_tmp0_ = *pair;
#line 164 "krcfile.vala"
	_tmp1_ = _tmp0_;
#line 164 "krcfile.vala"
	_tmp2_ = _krc_file_key_value_pair_dup0 (&_tmp1_);
#line 164 "krcfile.vala"
	(*group).key_value_pairs = g_list_insert_before ((*group).key_value_pairs, sibling, _tmp2_);
#line 1212 "krcfile.c"
}

static void
krc_file_add_key (KRcFile* self,
                  KRcFileGroup* group,
                  const gchar* key,
                  const gchar* value)
{
	KRcFileKeyValuePair pair = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GList* lp = NULL;
	GList* _tmp2_;
	KRcFileKeyValuePair _tmp10_;
	GList* _tmp11_;
#line 167 "krcfile.vala"
	g_return_if_fail (self != NULL);
#line 167 "krcfile.vala"
	g_return_if_fail (value != NULL);
#line 170 "krcfile.vala"
	memset (&pair, 0, sizeof (KRcFileKeyValuePair));
#line 171 "krcfile.vala"
	_tmp0_ = g_strdup (key);
#line 171 "krcfile.vala"
	_g_free0 (pair.key);
#line 171 "krcfile.vala"
	pair.key = _tmp0_;
#line 172 "krcfile.vala"
	_tmp1_ = g_strdup (value);
#line 172 "krcfile.vala"
	_g_free0 (pair.value);
#line 172 "krcfile.vala"
	pair.value = _tmp1_;
#line 173 "krcfile.vala"
	_tmp2_ = (*group).key_value_pairs;
#line 173 "krcfile.vala"
	lp = _tmp2_;
#line 174 "krcfile.vala"
	while (TRUE) {
#line 1252 "krcfile.c"
		gboolean _tmp3_ = FALSE;
		GList* _tmp4_;
		GList* _tmp8_;
		GList* _tmp9_;
#line 174 "krcfile.vala"
		_tmp4_ = lp;
#line 174 "krcfile.vala"
		if (_tmp4_ != NULL) {
#line 1261 "krcfile.c"
			GList* _tmp5_;
			gconstpointer _tmp6_;
			const gchar* _tmp7_;
#line 174 "krcfile.vala"
			_tmp5_ = lp;
#line 174 "krcfile.vala"
			_tmp6_ = _tmp5_->data;
#line 174 "krcfile.vala"
			_tmp7_ = (*((KRcFileKeyValuePair*) _tmp6_)).key;
#line 174 "krcfile.vala"
			_tmp3_ = _tmp7_ == NULL;
#line 1273 "krcfile.c"
		} else {
#line 174 "krcfile.vala"
			_tmp3_ = FALSE;
#line 1277 "krcfile.c"
		}
#line 174 "krcfile.vala"
		if (!_tmp3_) {
#line 174 "krcfile.vala"
			break;
#line 1283 "krcfile.c"
		}
#line 175 "krcfile.vala"
		_tmp8_ = lp;
#line 175 "krcfile.vala"
		_tmp9_ = _tmp8_->next;
#line 175 "krcfile.vala"
		lp = _tmp9_;
#line 1291 "krcfile.c"
	}
#line 176 "krcfile.vala"
	_tmp10_ = pair;
#line 176 "krcfile.vala"
	_tmp11_ = lp;
#line 176 "krcfile.vala"
	krc_file_add_key_value_pair (self, group, &_tmp10_, _tmp11_);
#line 167 "krcfile.vala"
	krc_file_key_value_pair_destroy (&pair);
#line 1301 "krcfile.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1324 "krcfile.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1333 "krcfile.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1352 "krcfile.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1356 "krcfile.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1362 "krcfile.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1372 "krcfile.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1380 "krcfile.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1384 "krcfile.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1390 "krcfile.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1400 "krcfile.c"
}

static void
krc_file_parse_comment (KRcFile* self,
                        const gchar* line,
                        glong length)
{
	KRcFileKeyValuePair pair = {0};
	gchar* _tmp0_;
	KRcFileGroup* _tmp1_;
	KRcFileKeyValuePair _tmp2_;
	KRcFileKeyValuePair _tmp3_;
	KRcFileKeyValuePair* _tmp4_;
#line 179 "krcfile.vala"
	g_return_if_fail (self != NULL);
#line 179 "krcfile.vala"
	g_return_if_fail (line != NULL);
#line 180 "krcfile.vala"
	memset (&pair, 0, sizeof (KRcFileKeyValuePair));
#line 181 "krcfile.vala"
	_g_free0 (pair.key);
#line 181 "krcfile.vala"
	pair.key = NULL;
#line 182 "krcfile.vala"
	_tmp0_ = string_substring (line, (glong) 0, length);
#line 182 "krcfile.vala"
	_g_free0 (pair.value);
#line 182 "krcfile.vala"
	pair.value = _tmp0_;
#line 183 "krcfile.vala"
	_tmp1_ = self->priv->m_current_group;
#line 183 "krcfile.vala"
	_tmp2_ = pair;
#line 183 "krcfile.vala"
	_tmp3_ = _tmp2_;
#line 183 "krcfile.vala"
	_tmp4_ = _krc_file_key_value_pair_dup0 (&_tmp3_);
#line 183 "krcfile.vala"
	(*_tmp1_).key_value_pairs = g_list_prepend ((*_tmp1_).key_value_pairs, _tmp4_);
#line 179 "krcfile.vala"
	krc_file_key_value_pair_destroy (&pair);
#line 1442 "krcfile.c"
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1341 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1342 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 1456 "krcfile.c"
		gchar* _tmp0_;
#line 1343 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1343 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1344 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1345 "glib-2.0.vapi"
		result = TRUE;
#line 1345 "glib-2.0.vapi"
		if (c) {
#line 1345 "glib-2.0.vapi"
			*c = _vala_c;
#line 1470 "krcfile.c"
		}
#line 1345 "glib-2.0.vapi"
		return result;
#line 1474 "krcfile.c"
	} else {
#line 1347 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1348 "glib-2.0.vapi"
		result = FALSE;
#line 1348 "glib-2.0.vapi"
		if (c) {
#line 1348 "glib-2.0.vapi"
			*c = _vala_c;
#line 1484 "krcfile.c"
		}
#line 1348 "glib-2.0.vapi"
		return result;
#line 1488 "krcfile.c"
	}
}

static void
krc_file_parse_group (KRcFile* self,
                      const gchar* line,
                      glong length,
                      GError** error)
{
	gint l = 0;
	gunichar ch = 0U;
	gchar* group_name = NULL;
	gchar* _tmp3_;
	GList* group_node = NULL;
	GList* _tmp5_;
	GList* _tmp6_;
	KRcFileGroup group = {0};
	gchar* _tmp9_;
	KRcFileGroup _tmp10_;
	KRcFileGroup _tmp11_;
	KRcFileGroup* _tmp12_;
	GList* _tmp13_;
	gconstpointer _tmp14_;
	GError* _inner_error0_ = NULL;
#line 186 "krcfile.vala"
	g_return_if_fail (self != NULL);
#line 186 "krcfile.vala"
	g_return_if_fail (line != NULL);
#line 188 "krcfile.vala"
	l = (gint) length;
#line 189 "krcfile.vala"
	if (l < 0) {
#line 1521 "krcfile.c"
		GError* _tmp0_;
#line 190 "krcfile.vala"
		_tmp0_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE, "Too long group name %s against IMT_MAX", line);
#line 190 "krcfile.vala"
		_inner_error0_ = _tmp0_;
#line 190 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 190 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 190 "krcfile.vala"
			return;
#line 1533 "krcfile.c"
		} else {
#line 190 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 190 "krcfile.vala"
			return;
#line 1541 "krcfile.c"
		}
	}
#line 193 "krcfile.vala"
	_vala_assert (l > 2, "l > 2");
#line 195 "krcfile.vala"
	while (TRUE) {
#line 1548 "krcfile.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 195 "krcfile.vala"
		_tmp2_ = string_get_prev_char (line, &l, &_tmp1_);
#line 195 "krcfile.vala"
		ch = _tmp1_;
#line 195 "krcfile.vala"
		if (!_tmp2_) {
#line 195 "krcfile.vala"
			break;
#line 1559 "krcfile.c"
		}
#line 196 "krcfile.vala"
		if (ch != ((gunichar) ']')) {
#line 197 "krcfile.vala"
			break;
#line 1565 "krcfile.c"
		}
	}
#line 199 "krcfile.vala"
	_tmp3_ = string_substring (line, (glong) 1, (glong) l);
#line 199 "krcfile.vala"
	group_name = _tmp3_;
#line 200 "krcfile.vala"
	if (!krc_file_is_group_name (self, group_name)) {
#line 1574 "krcfile.c"
		GError* _tmp4_;
#line 201 "krcfile.vala"
		_tmp4_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE, "Invalid group name %s", group_name);
#line 201 "krcfile.vala"
		_inner_error0_ = _tmp4_;
#line 201 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 201 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 201 "krcfile.vala"
			_g_free0 (group_name);
#line 201 "krcfile.vala"
			return;
#line 1588 "krcfile.c"
		} else {
#line 201 "krcfile.vala"
			_g_free0 (group_name);
#line 201 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 201 "krcfile.vala"
			return;
#line 1598 "krcfile.c"
		}
	}
#line 204 "krcfile.vala"
	_tmp5_ = krc_file_get_group_node_with_name (self, group_name, FALSE, &_inner_error0_);
#line 204 "krcfile.vala"
	group_node = _tmp5_;
#line 204 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 204 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 204 "krcfile.vala"
			_g_free0 (group_name);
#line 204 "krcfile.vala"
			return;
#line 1615 "krcfile.c"
		} else {
#line 204 "krcfile.vala"
			_g_free0 (group_name);
#line 204 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 204 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 204 "krcfile.vala"
			return;
#line 1625 "krcfile.c"
		}
	}
#line 206 "krcfile.vala"
	_tmp6_ = group_node;
#line 206 "krcfile.vala"
	if (_tmp6_ != NULL) {
#line 1632 "krcfile.c"
		GList* _tmp7_;
		gconstpointer _tmp8_;
#line 207 "krcfile.vala"
		_tmp7_ = group_node;
#line 207 "krcfile.vala"
		_tmp8_ = _tmp7_->data;
#line 207 "krcfile.vala"
		self->priv->m_current_group = (KRcFileGroup*) ((KRcFileGroup*) _tmp8_);
#line 208 "krcfile.vala"
		_g_free0 (group_name);
#line 208 "krcfile.vala"
		return;
#line 1645 "krcfile.c"
	}
#line 210 "krcfile.vala"
	memset (&group, 0, sizeof (KRcFileGroup));
#line 211 "krcfile.vala"
	_tmp9_ = g_strdup (group_name);
#line 211 "krcfile.vala"
	_g_free0 (group.name);
#line 211 "krcfile.vala"
	group.name = _tmp9_;
#line 212 "krcfile.vala"
	_tmp10_ = group;
#line 212 "krcfile.vala"
	_tmp11_ = _tmp10_;
#line 212 "krcfile.vala"
	_tmp12_ = _krc_file_group_dup0 (&_tmp11_);
#line 212 "krcfile.vala"
	self->priv->m_groups = g_list_prepend (self->priv->m_groups, _tmp12_);
#line 213 "krcfile.vala"
	_tmp13_ = self->priv->m_groups;
#line 213 "krcfile.vala"
	_tmp14_ = _tmp13_->data;
#line 213 "krcfile.vala"
	self->priv->m_current_group = (KRcFileGroup*) ((KRcFileGroup*) _tmp14_);
#line 186 "krcfile.vala"
	krc_file_group_destroy (&group);
#line 186 "krcfile.vala"
	_g_free0 (group_name);
#line 1673 "krcfile.c"
}

static gchar*
string_chomp (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1397 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1398 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1398 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1399 "glib-2.0.vapi"
	g_strchomp (_result_);
#line 1400 "glib-2.0.vapi"
	result = _result_;
#line 1400 "glib-2.0.vapi"
	return result;
#line 1694 "krcfile.c"
}

static gchar*
string_chug (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1405 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1406 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1406 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1407 "glib-2.0.vapi"
	g_strchug (_result_);
#line 1408 "glib-2.0.vapi"
	result = _result_;
#line 1408 "glib-2.0.vapi"
	return result;
#line 1715 "krcfile.c"
}

static void
krc_file_parse_key_value_pair (KRcFile* self,
                               const gchar* line,
                               glong length,
                               GError** error)
{
	KRcFileGroup* _tmp0_;
	const gchar* _tmp1_;
	gint key_end = 0;
	gint value_start = 0;
	gint _tmp3_;
	gint _tmp4_;
	gchar* key = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* value = NULL;
	gint _tmp10_;
	gint _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	KRcFileGroup* _tmp15_;
	const gchar* _tmp16_;
	gboolean _tmp17_ = FALSE;
	const gchar* _tmp18_;
	KRcFileKeyValuePair pair = {0};
	const gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	KRcFileGroup* _tmp26_;
	KRcFileKeyValuePair _tmp27_;
	KRcFileGroup* _tmp28_;
	GList* _tmp29_;
	GError* _inner_error0_ = NULL;
#line 216 "krcfile.vala"
	g_return_if_fail (self != NULL);
#line 216 "krcfile.vala"
	g_return_if_fail (line != NULL);
#line 218 "krcfile.vala"
	_tmp0_ = self->priv->m_current_group;
#line 218 "krcfile.vala"
	_tmp1_ = (*_tmp0_).name;
#line 218 "krcfile.vala"
	if (_tmp1_ == NULL) {
#line 1764 "krcfile.c"
		GError* _tmp2_;
#line 219 "krcfile.vala"
		_tmp2_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND, "Key file does not start with a group");
#line 219 "krcfile.vala"
		_inner_error0_ = _tmp2_;
#line 219 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 219 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 219 "krcfile.vala"
			return;
#line 1776 "krcfile.c"
		} else {
#line 219 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 219 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 219 "krcfile.vala"
			return;
#line 1784 "krcfile.c"
		}
	}
#line 222 "krcfile.vala"
	key_end = string_index_of_char (line, (gunichar) '=', 0);
#line 223 "krcfile.vala"
	value_start = key_end;
#line 224 "krcfile.vala"
	g_warn_if_fail (key_end != -1);
#line 225 "krcfile.vala"
	_tmp3_ = key_end;
#line 225 "krcfile.vala"
	key_end = _tmp3_ - 1;
#line 226 "krcfile.vala"
	_tmp4_ = value_start;
#line 226 "krcfile.vala"
	value_start = _tmp4_ + 1;
#line 227 "krcfile.vala"
	_tmp5_ = string_substring (line, (glong) 0, (glong) (key_end + 1));
#line 227 "krcfile.vala"
	key = _tmp5_;
#line 228 "krcfile.vala"
	_tmp6_ = key;
#line 228 "krcfile.vala"
	_tmp7_ = string_chomp (_tmp6_);
#line 228 "krcfile.vala"
	_g_free0 (key);
#line 228 "krcfile.vala"
	key = _tmp7_;
#line 229 "krcfile.vala"
	if (!krc_file_is_key_name (self, line, (gsize) (key_end + 1))) {
#line 1815 "krcfile.c"
		const gchar* _tmp8_;
		GError* _tmp9_;
#line 230 "krcfile.vala"
		_tmp8_ = key;
#line 230 "krcfile.vala"
		_tmp9_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE, "Invalid key name: %s", _tmp8_);
#line 230 "krcfile.vala"
		_inner_error0_ = _tmp9_;
#line 230 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 230 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 230 "krcfile.vala"
			_g_free0 (key);
#line 230 "krcfile.vala"
			return;
#line 1832 "krcfile.c"
		} else {
#line 230 "krcfile.vala"
			_g_free0 (key);
#line 230 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 230 "krcfile.vala"
			return;
#line 1842 "krcfile.c"
		}
	}
#line 233 "krcfile.vala"
	_tmp10_ = strlen (line);
#line 233 "krcfile.vala"
	_tmp11_ = _tmp10_;
#line 233 "krcfile.vala"
	_tmp12_ = string_substring (line, (glong) value_start, (glong) (_tmp11_ - value_start));
#line 233 "krcfile.vala"
	value = _tmp12_;
#line 234 "krcfile.vala"
	_tmp13_ = value;
#line 234 "krcfile.vala"
	_tmp14_ = string_chug (_tmp13_);
#line 234 "krcfile.vala"
	_g_free0 (value);
#line 234 "krcfile.vala"
	value = _tmp14_;
#line 235 "krcfile.vala"
	_tmp15_ = self->priv->m_current_group;
#line 235 "krcfile.vala"
	_tmp16_ = (*_tmp15_).name;
#line 235 "krcfile.vala"
	_vala_assert (_tmp16_ != NULL, "m_current_group.name != null");
#line 236 "krcfile.vala"
	_tmp18_ = key;
#line 236 "krcfile.vala"
	if (g_strcmp0 (_tmp18_, "Encoding") == 0) {
#line 1871 "krcfile.c"
		const gchar* _tmp19_;
#line 236 "krcfile.vala"
		_tmp19_ = value;
#line 236 "krcfile.vala"
		_tmp17_ = g_strcmp0 (_tmp19_, "UTF-8") != 0;
#line 1877 "krcfile.c"
	} else {
#line 236 "krcfile.vala"
		_tmp17_ = FALSE;
#line 1881 "krcfile.c"
	}
#line 236 "krcfile.vala"
	if (_tmp17_) {
#line 1885 "krcfile.c"
		const gchar* _tmp20_;
		GError* _tmp21_;
#line 237 "krcfile.vala"
		_tmp20_ = value;
#line 237 "krcfile.vala"
		_tmp21_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_UNKNOWN_ENCODING, "Key file contains unsupported encoding %s", _tmp20_);
#line 237 "krcfile.vala"
		_inner_error0_ = _tmp21_;
#line 237 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 237 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 237 "krcfile.vala"
			_g_free0 (value);
#line 237 "krcfile.vala"
			_g_free0 (key);
#line 237 "krcfile.vala"
			return;
#line 1904 "krcfile.c"
		} else {
#line 237 "krcfile.vala"
			_g_free0 (value);
#line 237 "krcfile.vala"
			_g_free0 (key);
#line 237 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 237 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 237 "krcfile.vala"
			return;
#line 1916 "krcfile.c"
		}
	}
#line 240 "krcfile.vala"
	memset (&pair, 0, sizeof (KRcFileKeyValuePair));
#line 241 "krcfile.vala"
	_tmp22_ = key;
#line 241 "krcfile.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 241 "krcfile.vala"
	_g_free0 (pair.key);
#line 241 "krcfile.vala"
	pair.key = _tmp23_;
#line 242 "krcfile.vala"
	_tmp24_ = value;
#line 242 "krcfile.vala"
	_tmp25_ = g_strdup (_tmp24_);
#line 242 "krcfile.vala"
	_g_free0 (pair.value);
#line 242 "krcfile.vala"
	pair.value = _tmp25_;
#line 243 "krcfile.vala"
	_tmp26_ = self->priv->m_current_group;
#line 243 "krcfile.vala"
	_tmp27_ = pair;
#line 243 "krcfile.vala"
	_tmp28_ = self->priv->m_current_group;
#line 243 "krcfile.vala"
	_tmp29_ = (*_tmp28_).key_value_pairs;
#line 243 "krcfile.vala"
	krc_file_add_key_value_pair (self, _tmp26_, &_tmp27_, _tmp29_);
#line 216 "krcfile.vala"
	krc_file_key_value_pair_destroy (&pair);
#line 216 "krcfile.vala"
	_g_free0 (value);
#line 216 "krcfile.vala"
	_g_free0 (key);
#line 1953 "krcfile.c"
}

static void
krc_file_parse_line (KRcFile* self,
                     const gchar* line,
                     glong length,
                     GError** error)
{
	gchar* _line = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 248 "krcfile.vala"
	g_return_if_fail (self != NULL);
#line 248 "krcfile.vala"
	g_return_if_fail (line != NULL);
#line 250 "krcfile.vala"
	_tmp0_ = g_strdup (line);
#line 250 "krcfile.vala"
	_line = _tmp0_;
#line 251 "krcfile.vala"
	_tmp1_ = _line;
#line 251 "krcfile.vala"
	_tmp2_ = string_chug (_tmp1_);
#line 251 "krcfile.vala"
	_g_free0 (_line);
#line 251 "krcfile.vala"
	_line = _tmp2_;
#line 252 "krcfile.vala"
	_tmp3_ = _line;
#line 252 "krcfile.vala"
	if (krc_file_is_comment (self, _tmp3_)) {
#line 253 "krcfile.vala"
		krc_file_parse_comment (self, line, length);
#line 1992 "krcfile.c"
	}
#line 254 "krcfile.vala"
	_tmp4_ = _line;
#line 254 "krcfile.vala"
	if (krc_file_is_group (self, _tmp4_)) {
#line 1998 "krcfile.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 255 "krcfile.vala"
		_tmp5_ = _line;
#line 255 "krcfile.vala"
		_tmp6_ = _line;
#line 255 "krcfile.vala"
		_tmp7_ = strlen (_tmp6_);
#line 255 "krcfile.vala"
		_tmp8_ = _tmp7_;
#line 255 "krcfile.vala"
		krc_file_parse_group (self, _tmp5_, length - (length - _tmp8_), &_inner_error0_);
#line 255 "krcfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 255 "krcfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 255 "krcfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 255 "krcfile.vala"
				_g_free0 (_line);
#line 255 "krcfile.vala"
				return;
#line 2023 "krcfile.c"
			} else {
#line 255 "krcfile.vala"
				_g_free0 (_line);
#line 255 "krcfile.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 255 "krcfile.vala"
				g_clear_error (&_inner_error0_);
#line 255 "krcfile.vala"
				return;
#line 2033 "krcfile.c"
			}
		}
	}
#line 256 "krcfile.vala"
	_tmp9_ = _line;
#line 256 "krcfile.vala"
	if (krc_file_is_key_value_pair (self, _tmp9_)) {
#line 2041 "krcfile.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 257 "krcfile.vala"
		_tmp10_ = _line;
#line 257 "krcfile.vala"
		_tmp11_ = _line;
#line 257 "krcfile.vala"
		_tmp12_ = strlen (_tmp11_);
#line 257 "krcfile.vala"
		_tmp13_ = _tmp12_;
#line 257 "krcfile.vala"
		krc_file_parse_key_value_pair (self, _tmp10_, length - (length - _tmp13_), &_inner_error0_);
#line 257 "krcfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 257 "krcfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 257 "krcfile.vala"
				g_propagate_error (error, _inner_error0_);
#line 257 "krcfile.vala"
				_g_free0 (_line);
#line 257 "krcfile.vala"
				return;
#line 2066 "krcfile.c"
			} else {
#line 257 "krcfile.vala"
				_g_free0 (_line);
#line 257 "krcfile.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 257 "krcfile.vala"
				g_clear_error (&_inner_error0_);
#line 257 "krcfile.vala"
				return;
#line 2076 "krcfile.c"
			}
		}
	}
#line 248 "krcfile.vala"
	_g_free0 (_line);
#line 2082 "krcfile.c"
}

static gboolean
krc_file_parse_data (KRcFile* self,
                     const gchar* data,
                     gsize length)
{
	glong i = 0L;
	glong offset = 0L;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 262 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 262 "krcfile.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 263 "krcfile.vala"
	i = (glong) 0;
#line 264 "krcfile.vala"
	offset = (glong) 0;
#line 265 "krcfile.vala"
	while (TRUE) {
#line 2104 "krcfile.c"
		gchar ch = '\0';
		glong _tmp20_;
#line 265 "krcfile.vala"
		if (!(((gsize) i) < length)) {
#line 265 "krcfile.vala"
			break;
#line 2111 "krcfile.c"
		}
#line 266 "krcfile.vala"
		ch = string_get (data, i);
#line 267 "krcfile.vala"
		if (ch == '\n') {
#line 2117 "krcfile.c"
			glong sub_length = 0L;
			gchar* sub = NULL;
			gchar* _tmp0_;
			gboolean _tmp1_ = FALSE;
			const gchar* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
#line 268 "krcfile.vala"
			sub_length = i - offset;
#line 269 "krcfile.vala"
			_tmp0_ = string_substring (data, offset, sub_length);
#line 269 "krcfile.vala"
			sub = _tmp0_;
#line 270 "krcfile.vala"
			offset = i + 1;
#line 271 "krcfile.vala"
			_tmp2_ = sub;
#line 271 "krcfile.vala"
			_tmp3_ = strlen (_tmp2_);
#line 271 "krcfile.vala"
			_tmp4_ = _tmp3_;
#line 271 "krcfile.vala"
			if (_tmp4_ > 0) {
#line 2141 "krcfile.c"
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 271 "krcfile.vala"
				_tmp5_ = sub;
#line 271 "krcfile.vala"
				_tmp6_ = sub;
#line 271 "krcfile.vala"
				_tmp7_ = strlen (_tmp6_);
#line 271 "krcfile.vala"
				_tmp8_ = _tmp7_;
#line 271 "krcfile.vala"
				_tmp1_ = string_get (_tmp5_, (glong) (_tmp8_ - 1)) == '\r';
#line 2156 "krcfile.c"
			} else {
#line 271 "krcfile.vala"
				_tmp1_ = FALSE;
#line 2160 "krcfile.c"
			}
#line 271 "krcfile.vala"
			if (_tmp1_) {
#line 2164 "krcfile.c"
				const gchar* _tmp9_;
				glong _tmp10_;
				gchar* _tmp11_;
#line 272 "krcfile.vala"
				_tmp9_ = sub;
#line 272 "krcfile.vala"
				sub_length = sub_length - 1;
#line 272 "krcfile.vala"
				_tmp10_ = sub_length;
#line 272 "krcfile.vala"
				_tmp11_ = string_substring (_tmp9_, (glong) 0, _tmp10_);
#line 272 "krcfile.vala"
				_g_free0 (sub);
#line 272 "krcfile.vala"
				sub = _tmp11_;
#line 2180 "krcfile.c"
			}
			{
				const gchar* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 274 "krcfile.vala"
				_tmp12_ = sub;
#line 274 "krcfile.vala"
				_tmp13_ = strlen (_tmp12_);
#line 274 "krcfile.vala"
				_tmp14_ = _tmp13_;
#line 274 "krcfile.vala"
				if (_tmp14_ == 0) {
#line 275 "krcfile.vala"
					krc_file_parse_comment (self, "", (glong) 0);
#line 2196 "krcfile.c"
				} else {
					const gchar* _tmp15_;
#line 277 "krcfile.vala"
					_tmp15_ = sub;
#line 277 "krcfile.vala"
					krc_file_parse_line (self, _tmp15_, sub_length, &_inner_error0_);
#line 277 "krcfile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2205 "krcfile.c"
						gboolean _tmp16_ = FALSE;
#line 277 "krcfile.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2209 "krcfile.c"
							goto __catch0_g_key_file_error;
						}
#line 277 "krcfile.vala"
						_g_free0 (sub);
#line 277 "krcfile.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 277 "krcfile.vala"
						g_clear_error (&_inner_error0_);
#line 277 "krcfile.vala"
						return _tmp16_;
#line 2220 "krcfile.c"
					}
				}
			}
			goto __finally0;
			__catch0_g_key_file_error:
			{
				GError* e = NULL;
				GError* _tmp17_;
				const gchar* _tmp18_;
#line 273 "krcfile.vala"
				e = _inner_error0_;
#line 273 "krcfile.vala"
				_inner_error0_ = NULL;
#line 279 "krcfile.vala"
				_tmp17_ = e;
#line 279 "krcfile.vala"
				_tmp18_ = _tmp17_->message;
#line 279 "krcfile.vala"
				g_warning ("krcfile.vala:279: Failed to load data: %s", _tmp18_);
#line 280 "krcfile.vala"
				result = FALSE;
#line 280 "krcfile.vala"
				_g_error_free0 (e);
#line 280 "krcfile.vala"
				_g_free0 (sub);
#line 280 "krcfile.vala"
				return result;
#line 2248 "krcfile.c"
			}
			__finally0:
#line 273 "krcfile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2253 "krcfile.c"
				gboolean _tmp19_ = FALSE;
#line 273 "krcfile.vala"
				_g_free0 (sub);
#line 273 "krcfile.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "krcfile.vala"
				g_clear_error (&_inner_error0_);
#line 273 "krcfile.vala"
				return _tmp19_;
#line 2263 "krcfile.c"
			}
#line 267 "krcfile.vala"
			_g_free0 (sub);
#line 2267 "krcfile.c"
		}
#line 283 "krcfile.vala"
		_tmp20_ = i;
#line 283 "krcfile.vala"
		i = _tmp20_ + 1;
#line 2273 "krcfile.c"
	}
#line 285 "krcfile.vala"
	result = TRUE;
#line 285 "krcfile.vala"
	return result;
#line 2279 "krcfile.c"
}

gboolean
krc_file_load_from_file (KRcFile* self,
                         const gchar* path,
                         GKeyFileFlags flags,
                         GError** error)
{
	gchar* contents = NULL;
	gsize length = 0UL;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_ = NULL;
	gsize _tmp5_ = 0UL;
	gboolean _tmp6_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 288 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 288 "krcfile.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 292 "krcfile.vala"
	if (!g_file_test (path, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR)) {
#line 2303 "krcfile.c"
		GError* _tmp0_;
#line 294 "krcfile.vala"
		_tmp0_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_PARSE, "Not a regular file %s", path);
#line 294 "krcfile.vala"
		_inner_error0_ = _tmp0_;
#line 294 "krcfile.vala"
		if ((_inner_error0_->domain == G_KEY_FILE_ERROR) || (_inner_error0_->domain == G_FILE_ERROR)) {
#line 2311 "krcfile.c"
			gboolean _tmp1_ = FALSE;
#line 294 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 294 "krcfile.vala"
			return _tmp1_;
#line 2317 "krcfile.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 294 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 294 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 294 "krcfile.vala"
			return _tmp2_;
#line 2326 "krcfile.c"
		}
	}
#line 297 "krcfile.vala"
	contents = NULL;
#line 298 "krcfile.vala"
	length = (gsize) 0;
#line 299 "krcfile.vala"
	_tmp6_ = g_file_get_contents (path, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 299 "krcfile.vala"
	_g_free0 (contents);
#line 299 "krcfile.vala"
	contents = _tmp4_;
#line 299 "krcfile.vala"
	length = _tmp5_;
#line 299 "krcfile.vala"
	_tmp3_ = _tmp6_;
#line 299 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 299 "krcfile.vala"
		if ((_inner_error0_->domain == G_KEY_FILE_ERROR) || (_inner_error0_->domain == G_FILE_ERROR)) {
#line 2347 "krcfile.c"
			gboolean _tmp7_ = FALSE;
#line 299 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 299 "krcfile.vala"
			_g_free0 (contents);
#line 299 "krcfile.vala"
			return _tmp7_;
#line 2355 "krcfile.c"
		} else {
			gboolean _tmp8_ = FALSE;
#line 299 "krcfile.vala"
			_g_free0 (contents);
#line 299 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 299 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 299 "krcfile.vala"
			return _tmp8_;
#line 2366 "krcfile.c"
		}
	}
#line 299 "krcfile.vala"
	if (!_tmp3_) {
#line 300 "krcfile.vala"
		g_warning ("krcfile.vala:300: Failed to load %s", path);
#line 301 "krcfile.vala"
		result = FALSE;
#line 301 "krcfile.vala"
		_g_free0 (contents);
#line 301 "krcfile.vala"
		return result;
#line 2379 "krcfile.c"
	}
#line 303 "krcfile.vala"
	_tmp9_ = contents;
#line 303 "krcfile.vala"
	result = krc_file_parse_data (self, _tmp9_, length);
#line 303 "krcfile.vala"
	_g_free0 (contents);
#line 303 "krcfile.vala"
	return result;
#line 2389 "krcfile.c"
}

gboolean
krc_file_has_group (KRcFile* self,
                    const gchar* group_name)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 306 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 306 "krcfile.vala"
	g_return_val_if_fail (group_name != NULL, FALSE);
#line 2402 "krcfile.c"
	{
		GList* _tmp0_ = NULL;
		GList* _tmp1_;
#line 308 "krcfile.vala"
		_tmp1_ = krc_file_get_group_node_with_name (self, group_name, FALSE, &_inner_error0_);
#line 308 "krcfile.vala"
		_tmp0_ = _tmp1_;
#line 308 "krcfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2412 "krcfile.c"
			gboolean _tmp2_ = FALSE;
#line 308 "krcfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2416 "krcfile.c"
				goto __catch0_g_key_file_error;
			}
#line 308 "krcfile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 308 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 308 "krcfile.vala"
			return _tmp2_;
#line 2425 "krcfile.c"
		}
#line 308 "krcfile.vala"
		if (_tmp0_ != NULL) {
#line 309 "krcfile.vala"
			result = TRUE;
#line 309 "krcfile.vala"
			return result;
#line 2433 "krcfile.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
#line 307 "krcfile.vala"
		g_clear_error (&_inner_error0_);
#line 311 "krcfile.vala"
		g_assert_not_reached ();
#line 2443 "krcfile.c"
	}
	__finally0:
#line 307 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2448 "krcfile.c"
		gboolean _tmp3_ = FALSE;
#line 307 "krcfile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "krcfile.vala"
		g_clear_error (&_inner_error0_);
#line 307 "krcfile.vala"
		return _tmp3_;
#line 2456 "krcfile.c"
	}
#line 313 "krcfile.vala"
	result = FALSE;
#line 313 "krcfile.vala"
	return result;
#line 2462 "krcfile.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 325 "krcfile.vala"
	if ((*length) == (*size)) {
#line 325 "krcfile.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 325 "krcfile.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2477 "krcfile.c"
	}
#line 325 "krcfile.vala"
	(*array)[(*length)++] = value;
#line 325 "krcfile.vala"
	(*array)[*length] = NULL;
#line 2483 "krcfile.c"
}

gchar**
krc_file_get_keys (KRcFile* self,
                   const gchar* group_name,
                   gint* result_length1,
                   GError** error)
{
	gchar** keys = NULL;
	gchar** _tmp0_;
	gint keys_length1;
	gint _keys_size_;
	GList* group_node = NULL;
	GList* _tmp1_;
	GList* tmp = NULL;
	gconstpointer _tmp2_;
	GList* _tmp3_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 316 "krcfile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 316 "krcfile.vala"
	g_return_val_if_fail (group_name != NULL, NULL);
#line 317 "krcfile.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 317 "krcfile.vala"
	keys = _tmp0_;
#line 317 "krcfile.vala"
	keys_length1 = 0;
#line 317 "krcfile.vala"
	_keys_size_ = keys_length1;
#line 318 "krcfile.vala"
	_tmp1_ = krc_file_get_group_node_with_name (self, group_name, TRUE, &_inner_error0_);
#line 318 "krcfile.vala"
	group_node = _tmp1_;
#line 318 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 318 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 318 "krcfile.vala"
			keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 318 "krcfile.vala"
			return NULL;
#line 2531 "krcfile.c"
		} else {
#line 318 "krcfile.vala"
			keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 318 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 318 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 318 "krcfile.vala"
			return NULL;
#line 2541 "krcfile.c"
		}
	}
#line 320 "krcfile.vala"
	_tmp2_ = group_node->data;
#line 320 "krcfile.vala"
	_tmp3_ = (*((KRcFileGroup*) _tmp2_)).key_value_pairs;
#line 320 "krcfile.vala"
	tmp = _tmp3_;
#line 322 "krcfile.vala"
	while (TRUE) {
#line 2552 "krcfile.c"
		GList* _tmp4_;
		KRcFileKeyValuePair pair = {0};
		GList* _tmp5_;
		gconstpointer _tmp6_;
		KRcFileKeyValuePair _tmp7_;
		KRcFileKeyValuePair _tmp8_ = {0};
		KRcFileKeyValuePair _tmp9_;
		const gchar* _tmp10_;
		GList* _tmp14_;
		GList* _tmp15_;
#line 322 "krcfile.vala"
		_tmp4_ = tmp;
#line 322 "krcfile.vala"
		if (!(_tmp4_ != NULL)) {
#line 322 "krcfile.vala"
			break;
#line 2569 "krcfile.c"
		}
#line 323 "krcfile.vala"
		_tmp5_ = tmp;
#line 323 "krcfile.vala"
		_tmp6_ = _tmp5_->data;
#line 323 "krcfile.vala"
		_tmp7_ = *((KRcFileKeyValuePair*) _tmp6_);
#line 323 "krcfile.vala"
		krc_file_key_value_pair_copy (&_tmp7_, &_tmp8_);
#line 323 "krcfile.vala"
		pair = _tmp8_;
#line 324 "krcfile.vala"
		_tmp9_ = pair;
#line 324 "krcfile.vala"
		_tmp10_ = _tmp9_.key;
#line 324 "krcfile.vala"
		if (_tmp10_ != NULL) {
#line 2587 "krcfile.c"
			KRcFileKeyValuePair _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 325 "krcfile.vala"
			_tmp11_ = pair;
#line 325 "krcfile.vala"
			_tmp12_ = _tmp11_.key;
#line 325 "krcfile.vala"
			_tmp13_ = g_strdup (_tmp12_);
#line 325 "krcfile.vala"
			_vala_array_add1 (&keys, &keys_length1, &_keys_size_, _tmp13_);
#line 2599 "krcfile.c"
		}
#line 326 "krcfile.vala"
		_tmp14_ = tmp;
#line 326 "krcfile.vala"
		_tmp15_ = _tmp14_->next;
#line 326 "krcfile.vala"
		tmp = _tmp15_;
#line 322 "krcfile.vala"
		krc_file_key_value_pair_destroy (&pair);
#line 2609 "krcfile.c"
	}
#line 328 "krcfile.vala"
	_tmp16_ = keys;
#line 328 "krcfile.vala"
	_tmp16__length1 = keys_length1;
#line 328 "krcfile.vala"
	if (result_length1) {
#line 328 "krcfile.vala"
		*result_length1 = _tmp16__length1;
#line 2619 "krcfile.c"
	}
#line 328 "krcfile.vala"
	result = _tmp16_;
#line 328 "krcfile.vala"
	return result;
#line 2625 "krcfile.c"
}

gboolean
krc_file_has_key (KRcFile* self,
                  const gchar* group_name,
                  const gchar* key,
                  GError** error)
{
	GList* group_node = NULL;
	GList* _tmp0_;
	GList* tmp = NULL;
	GList* _tmp3_;
	gconstpointer _tmp4_;
	GList* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 331 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 331 "krcfile.vala"
	g_return_val_if_fail (group_name != NULL, FALSE);
#line 331 "krcfile.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 333 "krcfile.vala"
	_tmp0_ = krc_file_get_group_node_with_name (self, group_name, TRUE, &_inner_error0_);
#line 333 "krcfile.vala"
	group_node = _tmp0_;
#line 333 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 333 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2656 "krcfile.c"
			gboolean _tmp1_ = FALSE;
#line 333 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 333 "krcfile.vala"
			return _tmp1_;
#line 2662 "krcfile.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 333 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 333 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 333 "krcfile.vala"
			return _tmp2_;
#line 2671 "krcfile.c"
		}
	}
#line 335 "krcfile.vala"
	_tmp3_ = group_node;
#line 335 "krcfile.vala"
	_tmp4_ = _tmp3_->data;
#line 335 "krcfile.vala"
	_tmp5_ = (*((KRcFileGroup*) _tmp4_)).key_value_pairs;
#line 335 "krcfile.vala"
	tmp = _tmp5_;
#line 337 "krcfile.vala"
	while (TRUE) {
#line 2684 "krcfile.c"
		GList* _tmp6_;
		KRcFileKeyValuePair pair = {0};
		GList* _tmp7_;
		gconstpointer _tmp8_;
		KRcFileKeyValuePair _tmp9_;
		KRcFileKeyValuePair _tmp10_ = {0};
		KRcFileKeyValuePair _tmp11_;
		const gchar* _tmp12_;
		GList* _tmp13_;
		GList* _tmp14_;
#line 337 "krcfile.vala"
		_tmp6_ = tmp;
#line 337 "krcfile.vala"
		if (!(_tmp6_ != NULL)) {
#line 337 "krcfile.vala"
			break;
#line 2701 "krcfile.c"
		}
#line 338 "krcfile.vala"
		_tmp7_ = tmp;
#line 338 "krcfile.vala"
		_tmp8_ = _tmp7_->data;
#line 338 "krcfile.vala"
		_tmp9_ = *((KRcFileKeyValuePair*) _tmp8_);
#line 338 "krcfile.vala"
		krc_file_key_value_pair_copy (&_tmp9_, &_tmp10_);
#line 338 "krcfile.vala"
		pair = _tmp10_;
#line 339 "krcfile.vala"
		_tmp11_ = pair;
#line 339 "krcfile.vala"
		_tmp12_ = _tmp11_.key;
#line 339 "krcfile.vala"
		if (g_strcmp0 (_tmp12_, key) == 0) {
#line 340 "krcfile.vala"
			result = TRUE;
#line 340 "krcfile.vala"
			krc_file_key_value_pair_destroy (&pair);
#line 340 "krcfile.vala"
			return result;
#line 2725 "krcfile.c"
		}
#line 341 "krcfile.vala"
		_tmp13_ = tmp;
#line 341 "krcfile.vala"
		_tmp14_ = _tmp13_->next;
#line 341 "krcfile.vala"
		tmp = _tmp14_;
#line 337 "krcfile.vala"
		krc_file_key_value_pair_destroy (&pair);
#line 2735 "krcfile.c"
	}
#line 343 "krcfile.vala"
	result = FALSE;
#line 343 "krcfile.vala"
	return result;
#line 2741 "krcfile.c"
}

gboolean
krc_file_remove_group (KRcFile* self,
                       const gchar* group_name,
                       GError** error)
{
	GList* group_node = NULL;
	GList* _tmp0_;
	GList* tmp = NULL;
	gconstpointer _tmp3_;
	GList* _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 346 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 346 "krcfile.vala"
	g_return_val_if_fail (group_name != NULL, FALSE);
#line 347 "krcfile.vala"
	_tmp0_ = krc_file_get_group_node_with_name (self, group_name, TRUE, &_inner_error0_);
#line 347 "krcfile.vala"
	group_node = _tmp0_;
#line 347 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 347 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2768 "krcfile.c"
			gboolean _tmp1_ = FALSE;
#line 347 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 347 "krcfile.vala"
			return _tmp1_;
#line 2774 "krcfile.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 347 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 347 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 347 "krcfile.vala"
			return _tmp2_;
#line 2783 "krcfile.c"
		}
	}
#line 349 "krcfile.vala"
	_tmp3_ = group_node->data;
#line 349 "krcfile.vala"
	_tmp4_ = (*((KRcFileGroup*) _tmp3_)).key_value_pairs;
#line 349 "krcfile.vala"
	tmp = _tmp4_;
#line 351 "krcfile.vala"
	while (TRUE) {
#line 2794 "krcfile.c"
		GList* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
#line 351 "krcfile.vala"
		_tmp5_ = tmp;
#line 351 "krcfile.vala"
		if (!(_tmp5_ != NULL)) {
#line 351 "krcfile.vala"
			break;
#line 2804 "krcfile.c"
		}
#line 352 "krcfile.vala"
		_tmp6_ = tmp;
#line 352 "krcfile.vala"
		_krc_file_key_value_pair_free0 (_tmp6_->data);
#line 352 "krcfile.vala"
		_tmp6_->data = NULL;
#line 353 "krcfile.vala"
		_tmp7_ = tmp;
#line 353 "krcfile.vala"
		tmp = g_list_delete_link (tmp, _tmp7_);
#line 2816 "krcfile.c"
	}
#line 355 "krcfile.vala"
	_krc_file_group_free0 (group_node->data);
#line 355 "krcfile.vala"
	group_node->data = NULL;
#line 356 "krcfile.vala"
	self->priv->m_groups = g_list_delete_link (self->priv->m_groups, group_node);
#line 357 "krcfile.vala"
	result = TRUE;
#line 357 "krcfile.vala"
	return result;
#line 2828 "krcfile.c"
}

gboolean
krc_file_remove_key (KRcFile* self,
                     const gchar* group_name,
                     const gchar* key,
                     GError** error)
{
	GList* group_node = NULL;
	GList* _tmp0_;
	GList* tmp = NULL;
	GList* _tmp3_;
	gconstpointer _tmp4_;
	GList* _tmp5_;
	GList* _tmp14_;
	GList* _tmp18_;
	GList* _tmp19_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 360 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 360 "krcfile.vala"
	g_return_val_if_fail (group_name != NULL, FALSE);
#line 360 "krcfile.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 362 "krcfile.vala"
	_tmp0_ = krc_file_get_group_node_with_name (self, group_name, TRUE, &_inner_error0_);
#line 362 "krcfile.vala"
	group_node = _tmp0_;
#line 362 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 362 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2862 "krcfile.c"
			gboolean _tmp1_ = FALSE;
#line 362 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 362 "krcfile.vala"
			return _tmp1_;
#line 2868 "krcfile.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 362 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 362 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 362 "krcfile.vala"
			return _tmp2_;
#line 2877 "krcfile.c"
		}
	}
#line 364 "krcfile.vala"
	_tmp3_ = group_node;
#line 364 "krcfile.vala"
	_tmp4_ = _tmp3_->data;
#line 364 "krcfile.vala"
	_tmp5_ = (*((KRcFileGroup*) _tmp4_)).key_value_pairs;
#line 364 "krcfile.vala"
	tmp = _tmp5_;
#line 366 "krcfile.vala"
	while (TRUE) {
#line 2890 "krcfile.c"
		GList* _tmp6_;
		KRcFileKeyValuePair* pair = NULL;
		GList* _tmp7_;
		gconstpointer _tmp8_;
		KRcFileKeyValuePair* _tmp9_;
		KRcFileKeyValuePair* _tmp10_;
		const gchar* _tmp11_;
		GList* _tmp12_;
		GList* _tmp13_;
#line 366 "krcfile.vala"
		_tmp6_ = tmp;
#line 366 "krcfile.vala"
		if (!(_tmp6_ != NULL)) {
#line 366 "krcfile.vala"
			break;
#line 2906 "krcfile.c"
		}
#line 367 "krcfile.vala"
		_tmp7_ = tmp;
#line 367 "krcfile.vala"
		_tmp8_ = _tmp7_->data;
#line 367 "krcfile.vala"
		_tmp9_ = _krc_file_key_value_pair_dup0 ((KRcFileKeyValuePair*) _tmp8_);
#line 367 "krcfile.vala"
		pair = _tmp9_;
#line 368 "krcfile.vala"
		_tmp10_ = pair;
#line 368 "krcfile.vala"
		_tmp11_ = (*_tmp10_).key;
#line 368 "krcfile.vala"
		if (g_strcmp0 (_tmp11_, key) == 0) {
#line 369 "krcfile.vala"
			_krc_file_key_value_pair_free0 (pair);
#line 369 "krcfile.vala"
			break;
#line 2926 "krcfile.c"
		}
#line 370 "krcfile.vala"
		_tmp12_ = tmp;
#line 370 "krcfile.vala"
		_tmp13_ = _tmp12_->next;
#line 370 "krcfile.vala"
		tmp = _tmp13_;
#line 366 "krcfile.vala"
		_krc_file_key_value_pair_free0 (pair);
#line 2936 "krcfile.c"
	}
#line 372 "krcfile.vala"
	_tmp14_ = tmp;
#line 372 "krcfile.vala"
	if (_tmp14_ == NULL) {
#line 2942 "krcfile.c"
		GError* _tmp15_;
#line 373 "krcfile.vala"
		_tmp15_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND, "Key file does not have key %s in group %s", key, group_name);
#line 373 "krcfile.vala"
		_inner_error0_ = _tmp15_;
#line 373 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2950 "krcfile.c"
			gboolean _tmp16_ = FALSE;
#line 373 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 373 "krcfile.vala"
			return _tmp16_;
#line 2956 "krcfile.c"
		} else {
			gboolean _tmp17_ = FALSE;
#line 373 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 373 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 373 "krcfile.vala"
			return _tmp17_;
#line 2965 "krcfile.c"
		}
	}
#line 377 "krcfile.vala"
	_tmp18_ = tmp;
#line 377 "krcfile.vala"
	_krc_file_key_value_pair_free0 (_tmp18_->data);
#line 377 "krcfile.vala"
	_tmp18_->data = NULL;
#line 378 "krcfile.vala"
	_tmp19_ = tmp;
#line 378 "krcfile.vala"
	tmp = g_list_delete_link (tmp, _tmp19_);
#line 379 "krcfile.vala"
	result = TRUE;
#line 379 "krcfile.vala"
	return result;
#line 2982 "krcfile.c"
}

gchar*
krc_file_to_data (KRcFile* self,
                  gssize* length)
{
	gssize _vala_length = 0L;
	GString* data_string = NULL;
	GString* _tmp0_;
	GString* _tmp36_;
	GString* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* result;
#line 382 "krcfile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 383 "krcfile.vala"
	_tmp0_ = g_string_new ("");
#line 383 "krcfile.vala"
	data_string = _tmp0_;
#line 3003 "krcfile.c"
	{
		GList* group_node = NULL;
		GList* _tmp1_;
		GList* _tmp2_;
#line 384 "krcfile.vala"
		_tmp1_ = self->priv->m_groups;
#line 384 "krcfile.vala"
		_tmp2_ = g_list_last (_tmp1_);
#line 384 "krcfile.vala"
		group_node = _tmp2_;
#line 3014 "krcfile.c"
		{
			gboolean _tmp3_ = FALSE;
#line 384 "krcfile.vala"
			_tmp3_ = TRUE;
#line 384 "krcfile.vala"
			while (TRUE) {
#line 3021 "krcfile.c"
				GList* _tmp6_;
				KRcFileGroup* group = NULL;
				GList* _tmp7_;
				gconstpointer _tmp8_;
				KRcFileGroup* _tmp9_;
				KRcFileGroup* _tmp10_;
				const gchar* _tmp11_;
#line 384 "krcfile.vala"
				if (!_tmp3_) {
#line 3031 "krcfile.c"
					GList* _tmp4_;
					GList* _tmp5_;
#line 386 "krcfile.vala"
					_tmp4_ = group_node;
#line 386 "krcfile.vala"
					_tmp5_ = _tmp4_->prev;
#line 386 "krcfile.vala"
					group_node = _tmp5_;
#line 3040 "krcfile.c"
				}
#line 384 "krcfile.vala"
				_tmp3_ = FALSE;
#line 385 "krcfile.vala"
				_tmp6_ = group_node;
#line 385 "krcfile.vala"
				if (!(_tmp6_ != NULL)) {
#line 385 "krcfile.vala"
					break;
#line 3050 "krcfile.c"
				}
#line 387 "krcfile.vala"
				_tmp7_ = group_node;
#line 387 "krcfile.vala"
				_tmp8_ = _tmp7_->data;
#line 387 "krcfile.vala"
				_tmp9_ = _krc_file_group_dup0 ((KRcFileGroup*) _tmp8_);
#line 387 "krcfile.vala"
				group = _tmp9_;
#line 388 "krcfile.vala"
				_tmp10_ = group;
#line 388 "krcfile.vala"
				_tmp11_ = (*_tmp10_).name;
#line 388 "krcfile.vala"
				if (_tmp11_ != NULL) {
#line 3066 "krcfile.c"
					GString* _tmp12_;
					KRcFileGroup* _tmp13_;
					const gchar* _tmp14_;
#line 389 "krcfile.vala"
					_tmp12_ = data_string;
#line 389 "krcfile.vala"
					_tmp13_ = group;
#line 389 "krcfile.vala"
					_tmp14_ = (*_tmp13_).name;
#line 389 "krcfile.vala"
					g_string_append_printf (_tmp12_, "[%s]\n", _tmp14_);
#line 3078 "krcfile.c"
				}
				{
					GList* key_file_node = NULL;
					KRcFileGroup* _tmp15_;
					GList* _tmp16_;
					GList* _tmp17_;
#line 390 "krcfile.vala"
					_tmp15_ = group;
#line 390 "krcfile.vala"
					_tmp16_ = (*_tmp15_).key_value_pairs;
#line 390 "krcfile.vala"
					_tmp17_ = g_list_last (_tmp16_);
#line 390 "krcfile.vala"
					key_file_node = _tmp17_;
#line 3093 "krcfile.c"
					{
						gboolean _tmp18_ = FALSE;
#line 390 "krcfile.vala"
						_tmp18_ = TRUE;
#line 390 "krcfile.vala"
						while (TRUE) {
#line 3100 "krcfile.c"
							GList* _tmp21_;
							KRcFileKeyValuePair pair = {0};
							GList* _tmp22_;
							gconstpointer _tmp23_;
							KRcFileKeyValuePair _tmp24_;
							KRcFileKeyValuePair _tmp25_ = {0};
							KRcFileKeyValuePair _tmp26_;
							const gchar* _tmp27_;
#line 390 "krcfile.vala"
							if (!_tmp18_) {
#line 3111 "krcfile.c"
								GList* _tmp19_;
								GList* _tmp20_;
#line 393 "krcfile.vala"
								_tmp19_ = key_file_node;
#line 393 "krcfile.vala"
								_tmp20_ = _tmp19_->prev;
#line 393 "krcfile.vala"
								key_file_node = _tmp20_;
#line 3120 "krcfile.c"
							}
#line 390 "krcfile.vala"
							_tmp18_ = FALSE;
#line 392 "krcfile.vala"
							_tmp21_ = key_file_node;
#line 392 "krcfile.vala"
							if (!(_tmp21_ != NULL)) {
#line 392 "krcfile.vala"
								break;
#line 3130 "krcfile.c"
							}
#line 394 "krcfile.vala"
							_tmp22_ = key_file_node;
#line 394 "krcfile.vala"
							_tmp23_ = _tmp22_->data;
#line 394 "krcfile.vala"
							_tmp24_ = *((KRcFileKeyValuePair*) _tmp23_);
#line 394 "krcfile.vala"
							krc_file_key_value_pair_copy (&_tmp24_, &_tmp25_);
#line 394 "krcfile.vala"
							pair = _tmp25_;
#line 395 "krcfile.vala"
							_tmp26_ = pair;
#line 395 "krcfile.vala"
							_tmp27_ = _tmp26_.key;
#line 395 "krcfile.vala"
							if (_tmp27_ != NULL) {
#line 3148 "krcfile.c"
								GString* _tmp28_;
								KRcFileKeyValuePair _tmp29_;
								const gchar* _tmp30_;
								KRcFileKeyValuePair _tmp31_;
								const gchar* _tmp32_;
#line 396 "krcfile.vala"
								_tmp28_ = data_string;
#line 396 "krcfile.vala"
								_tmp29_ = pair;
#line 396 "krcfile.vala"
								_tmp30_ = _tmp29_.key;
#line 396 "krcfile.vala"
								_tmp31_ = pair;
#line 396 "krcfile.vala"
								_tmp32_ = _tmp31_.value;
#line 396 "krcfile.vala"
								g_string_append_printf (_tmp28_, "%s=%s\n", _tmp30_, _tmp32_);
#line 3166 "krcfile.c"
							} else {
								GString* _tmp33_;
								KRcFileKeyValuePair _tmp34_;
								const gchar* _tmp35_;
#line 398 "krcfile.vala"
								_tmp33_ = data_string;
#line 398 "krcfile.vala"
								_tmp34_ = pair;
#line 398 "krcfile.vala"
								_tmp35_ = _tmp34_.value;
#line 398 "krcfile.vala"
								g_string_append_printf (_tmp33_, "%s\n", _tmp35_);
#line 3179 "krcfile.c"
							}
#line 390 "krcfile.vala"
							krc_file_key_value_pair_destroy (&pair);
#line 3183 "krcfile.c"
						}
					}
				}
#line 384 "krcfile.vala"
				_krc_file_group_free0 (group);
#line 3189 "krcfile.c"
			}
		}
	}
#line 401 "krcfile.vala"
	_tmp36_ = data_string;
#line 401 "krcfile.vala"
	_vala_length = _tmp36_->len;
#line 402 "krcfile.vala"
	_tmp37_ = data_string;
#line 402 "krcfile.vala"
	_tmp38_ = _tmp37_->str;
#line 402 "krcfile.vala"
	_tmp39_ = g_strdup (_tmp38_);
#line 402 "krcfile.vala"
	result = _tmp39_;
#line 402 "krcfile.vala"
	_g_string_free0 (data_string);
#line 402 "krcfile.vala"
	if (length) {
#line 402 "krcfile.vala"
		*length = _vala_length;
#line 3211 "krcfile.c"
	}
#line 402 "krcfile.vala"
	return result;
#line 3215 "krcfile.c"
}

gboolean
krc_file_save_to_file (KRcFile* self,
                       const gchar* filename,
                       GError** error)
{
	gssize length = 0L;
	gchar* contents = NULL;
	gssize _tmp0_ = 0L;
	gchar* _tmp1_;
	gboolean retval = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 405 "krcfile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 405 "krcfile.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 406 "krcfile.vala"
	length = (gssize) 0;
#line 407 "krcfile.vala"
	_tmp1_ = krc_file_to_data (self, &_tmp0_);
#line 407 "krcfile.vala"
	length = _tmp0_;
#line 407 "krcfile.vala"
	contents = _tmp1_;
#line 408 "krcfile.vala"
	retval = g_file_set_contents (filename, contents, length, &_inner_error0_);
#line 408 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 408 "krcfile.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3248 "krcfile.c"
			gboolean _tmp2_ = FALSE;
#line 408 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 408 "krcfile.vala"
			_g_free0 (contents);
#line 408 "krcfile.vala"
			return _tmp2_;
#line 3256 "krcfile.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 408 "krcfile.vala"
			_g_free0 (contents);
#line 408 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 408 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 408 "krcfile.vala"
			return _tmp3_;
#line 3267 "krcfile.c"
		}
	}
#line 409 "krcfile.vala"
	result = retval;
#line 409 "krcfile.vala"
	_g_free0 (contents);
#line 409 "krcfile.vala"
	return result;
#line 3276 "krcfile.c"
}

gchar*
krc_file_get_value (KRcFile* self,
                    const gchar* group_name,
                    const gchar* key,
                    GError** error)
{
	GList* group_node = NULL;
	GList* _tmp0_;
	GList* tmp = NULL;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	GList* _tmp3_;
	GError* _tmp15_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 412 "krcfile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 412 "krcfile.vala"
	g_return_val_if_fail (group_name != NULL, NULL);
#line 412 "krcfile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 414 "krcfile.vala"
	_tmp0_ = krc_file_get_group_node_with_name (self, group_name, TRUE, &_inner_error0_);
#line 414 "krcfile.vala"
	group_node = _tmp0_;
#line 414 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 414 "krcfile.vala"
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 414 "krcfile.vala"
			g_propagate_error (error, _inner_error0_);
#line 414 "krcfile.vala"
			return NULL;
#line 3312 "krcfile.c"
		} else {
#line 414 "krcfile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 414 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 414 "krcfile.vala"
			return NULL;
#line 3320 "krcfile.c"
		}
	}
#line 416 "krcfile.vala"
	_tmp1_ = group_node;
#line 416 "krcfile.vala"
	_tmp2_ = _tmp1_->data;
#line 416 "krcfile.vala"
	_tmp3_ = (*((KRcFileGroup*) _tmp2_)).key_value_pairs;
#line 416 "krcfile.vala"
	tmp = _tmp3_;
#line 418 "krcfile.vala"
	while (TRUE) {
#line 3333 "krcfile.c"
		GList* _tmp4_;
		KRcFileKeyValuePair* pair = NULL;
		GList* _tmp5_;
		gconstpointer _tmp6_;
		KRcFileKeyValuePair* _tmp7_;
		KRcFileKeyValuePair* _tmp8_;
		const gchar* _tmp9_;
		GList* _tmp13_;
		GList* _tmp14_;
#line 418 "krcfile.vala"
		_tmp4_ = tmp;
#line 418 "krcfile.vala"
		if (!(_tmp4_ != NULL)) {
#line 418 "krcfile.vala"
			break;
#line 3349 "krcfile.c"
		}
#line 419 "krcfile.vala"
		_tmp5_ = tmp;
#line 419 "krcfile.vala"
		_tmp6_ = _tmp5_->data;
#line 419 "krcfile.vala"
		_tmp7_ = _krc_file_key_value_pair_dup0 ((KRcFileKeyValuePair*) _tmp6_);
#line 419 "krcfile.vala"
		pair = _tmp7_;
#line 420 "krcfile.vala"
		_tmp8_ = pair;
#line 420 "krcfile.vala"
		_tmp9_ = (*_tmp8_).key;
#line 420 "krcfile.vala"
		if (g_strcmp0 (_tmp9_, key) == 0) {
#line 3365 "krcfile.c"
			KRcFileKeyValuePair* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
#line 421 "krcfile.vala"
			_tmp10_ = pair;
#line 421 "krcfile.vala"
			_tmp11_ = (*_tmp10_).value;
#line 421 "krcfile.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 421 "krcfile.vala"
			result = _tmp12_;
#line 421 "krcfile.vala"
			_krc_file_key_value_pair_free0 (pair);
#line 421 "krcfile.vala"
			return result;
#line 3381 "krcfile.c"
		}
#line 422 "krcfile.vala"
		_tmp13_ = tmp;
#line 422 "krcfile.vala"
		_tmp14_ = _tmp13_->next;
#line 422 "krcfile.vala"
		tmp = _tmp14_;
#line 418 "krcfile.vala"
		_krc_file_key_value_pair_free0 (pair);
#line 3391 "krcfile.c"
	}
#line 424 "krcfile.vala"
	_tmp15_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND, "Key file does not have key %s in group %s", key, group_name);
#line 424 "krcfile.vala"
	_inner_error0_ = _tmp15_;
#line 424 "krcfile.vala"
	if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 424 "krcfile.vala"
		g_propagate_error (error, _inner_error0_);
#line 424 "krcfile.vala"
		return NULL;
#line 3403 "krcfile.c"
	} else {
#line 424 "krcfile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 424 "krcfile.vala"
		g_clear_error (&_inner_error0_);
#line 424 "krcfile.vala"
		return NULL;
#line 3411 "krcfile.c"
	}
}

void
krc_file_set_value (KRcFile* self,
                    const gchar* group_name,
                    const gchar* key,
                    const gchar* value)
{
	gint _tmp0_;
	gint _tmp1_;
	GList* group_node = NULL;
	GError* _inner_error0_ = NULL;
#line 429 "krcfile.vala"
	g_return_if_fail (self != NULL);
#line 429 "krcfile.vala"
	g_return_if_fail (group_name != NULL);
#line 429 "krcfile.vala"
	g_return_if_fail (key != NULL);
#line 429 "krcfile.vala"
	g_return_if_fail (value != NULL);
#line 432 "krcfile.vala"
	g_return_if_fail (krc_file_is_group_name (self, group_name));
#line 433 "krcfile.vala"
	_tmp0_ = strlen (key);
#line 433 "krcfile.vala"
	_tmp1_ = _tmp0_;
#line 433 "krcfile.vala"
	g_return_if_fail (krc_file_is_key_name (self, key, (gsize) _tmp1_));
#line 3441 "krcfile.c"
	{
		GList* _tmp2_ = NULL;
		GList* _tmp3_;
#line 436 "krcfile.vala"
		_tmp3_ = krc_file_get_group_node_with_name (self, group_name, FALSE, &_inner_error0_);
#line 436 "krcfile.vala"
		_tmp2_ = _tmp3_;
#line 436 "krcfile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 436 "krcfile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3453 "krcfile.c"
				goto __catch0_g_key_file_error;
			}
#line 436 "krcfile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 436 "krcfile.vala"
			g_clear_error (&_inner_error0_);
#line 436 "krcfile.vala"
			return;
#line 3462 "krcfile.c"
		}
#line 436 "krcfile.vala"
		group_node = _tmp2_;
#line 3466 "krcfile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
#line 435 "krcfile.vala"
		g_clear_error (&_inner_error0_);
#line 438 "krcfile.vala"
		g_assert_not_reached ();
#line 3475 "krcfile.c"
	}
	__finally0:
#line 435 "krcfile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 435 "krcfile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 435 "krcfile.vala"
		g_clear_error (&_inner_error0_);
#line 435 "krcfile.vala"
		return;
#line 3486 "krcfile.c"
	}
#line 440 "krcfile.vala"
	if (group_node == NULL) {
#line 3490 "krcfile.c"
		KRcFileGroup* last_group = NULL;
		GList* _tmp4_;
		gconstpointer _tmp5_;
		KRcFileGroup* _tmp6_;
		GList* _tmp7_;
		KRcFileGroup group = {0};
		gchar* _tmp12_;
		KRcFileGroup _tmp13_;
		KRcFileGroup _tmp14_;
		KRcFileGroup* _tmp15_;
		GList* _tmp16_;
		gconstpointer _tmp17_;
		KRcFileGroup* _tmp18_;
#line 441 "krcfile.vala"
		_tmp4_ = self->priv->m_groups;
#line 441 "krcfile.vala"
		_tmp5_ = _tmp4_->data;
#line 441 "krcfile.vala"
		last_group = (KRcFileGroup*) _tmp5_;
#line 442 "krcfile.vala"
		_tmp6_ = last_group;
#line 442 "krcfile.vala"
		_tmp7_ = (*_tmp6_).key_value_pairs;
#line 442 "krcfile.vala"
		if (_tmp7_ != NULL) {
#line 3516 "krcfile.c"
			KRcFileGroup* _tmp8_;
			GList* _tmp9_;
			gconstpointer _tmp10_;
			const gchar* _tmp11_;
#line 443 "krcfile.vala"
			_tmp8_ = last_group;
#line 443 "krcfile.vala"
			_tmp9_ = (*_tmp8_).key_value_pairs;
#line 443 "krcfile.vala"
			_tmp10_ = _tmp9_->data;
#line 443 "krcfile.vala"
			_tmp11_ = (*((KRcFileKeyValuePair*) _tmp10_)).key;
#line 443 "krcfile.vala"
			if (_tmp11_ != NULL) {
#line 444 "krcfile.vala"
				krc_file_parse_comment (self, "", (glong) 0);
#line 3533 "krcfile.c"
			}
		}
#line 446 "krcfile.vala"
		memset (&group, 0, sizeof (KRcFileGroup));
#line 447 "krcfile.vala"
		_tmp12_ = g_strdup (group_name);
#line 447 "krcfile.vala"
		_g_free0 (group.name);
#line 447 "krcfile.vala"
		group.name = _tmp12_;
#line 448 "krcfile.vala"
		_tmp13_ = group;
#line 448 "krcfile.vala"
		_tmp14_ = _tmp13_;
#line 448 "krcfile.vala"
		_tmp15_ = _krc_file_group_dup0 (&_tmp14_);
#line 448 "krcfile.vala"
		self->priv->m_groups = g_list_prepend (self->priv->m_groups, _tmp15_);
#line 449 "krcfile.vala"
		_tmp16_ = self->priv->m_groups;
#line 449 "krcfile.vala"
		_tmp17_ = _tmp16_->data;
#line 449 "krcfile.vala"
		self->priv->m_current_group = (KRcFileGroup*) ((KRcFileGroup*) _tmp17_);
#line 450 "krcfile.vala"
		_tmp18_ = self->priv->m_current_group;
#line 450 "krcfile.vala"
		krc_file_add_key (self, _tmp18_, key, value);
#line 440 "krcfile.vala"
		krc_file_group_destroy (&group);
#line 3564 "krcfile.c"
	} else {
		GList* tmp = NULL;
		gconstpointer _tmp19_;
		GList* _tmp20_;
		GList* _tmp29_;
#line 452 "krcfile.vala"
		_tmp19_ = group_node->data;
#line 452 "krcfile.vala"
		_tmp20_ = (*((KRcFileGroup*) _tmp19_)).key_value_pairs;
#line 452 "krcfile.vala"
		tmp = _tmp20_;
#line 454 "krcfile.vala"
		while (TRUE) {
#line 3578 "krcfile.c"
			GList* _tmp21_;
			KRcFileKeyValuePair* pair = NULL;
			GList* _tmp22_;
			gconstpointer _tmp23_;
			KRcFileKeyValuePair* _tmp24_;
			KRcFileKeyValuePair* _tmp25_;
			const gchar* _tmp26_;
			GList* _tmp27_;
			GList* _tmp28_;
#line 454 "krcfile.vala"
			_tmp21_ = tmp;
#line 454 "krcfile.vala"
			if (!(_tmp21_ != NULL)) {
#line 454 "krcfile.vala"
				break;
#line 3594 "krcfile.c"
			}
#line 455 "krcfile.vala"
			_tmp22_ = tmp;
#line 455 "krcfile.vala"
			_tmp23_ = _tmp22_->data;
#line 455 "krcfile.vala"
			_tmp24_ = _krc_file_key_value_pair_dup0 ((KRcFileKeyValuePair*) _tmp23_);
#line 455 "krcfile.vala"
			pair = _tmp24_;
#line 456 "krcfile.vala"
			_tmp25_ = pair;
#line 456 "krcfile.vala"
			_tmp26_ = (*_tmp25_).key;
#line 456 "krcfile.vala"
			if (g_strcmp0 (_tmp26_, key) == 0) {
#line 457 "krcfile.vala"
				_krc_file_key_value_pair_free0 (pair);
#line 457 "krcfile.vala"
				break;
#line 3614 "krcfile.c"
			}
#line 458 "krcfile.vala"
			_tmp27_ = tmp;
#line 458 "krcfile.vala"
			_tmp28_ = _tmp27_->next;
#line 458 "krcfile.vala"
			tmp = _tmp28_;
#line 454 "krcfile.vala"
			_krc_file_key_value_pair_free0 (pair);
#line 3624 "krcfile.c"
		}
#line 460 "krcfile.vala"
		_tmp29_ = tmp;
#line 460 "krcfile.vala"
		if (_tmp29_ != NULL) {
#line 3630 "krcfile.c"
			GList* _tmp30_;
			gconstpointer _tmp31_;
			gchar* _tmp32_;
#line 461 "krcfile.vala"
			_tmp30_ = tmp;
#line 461 "krcfile.vala"
			_tmp31_ = _tmp30_->data;
#line 461 "krcfile.vala"
			_tmp32_ = g_strdup (value);
#line 461 "krcfile.vala"
			_g_free0 ((*((KRcFileKeyValuePair*) _tmp31_)).value);
#line 461 "krcfile.vala"
			(*((KRcFileKeyValuePair*) _tmp31_)).value = _tmp32_;
#line 3644 "krcfile.c"
		} else {
			gconstpointer _tmp33_;
#line 463 "krcfile.vala"
			_tmp33_ = group_node->data;
#line 463 "krcfile.vala"
			krc_file_add_key (self, (KRcFileGroup*) _tmp33_, key, value);
#line 3651 "krcfile.c"
		}
	}
}

static void
value_krc_file_init (GValue* value)
{
#line 33 "krcfile.vala"
	value->data[0].v_pointer = NULL;
#line 3661 "krcfile.c"
}

static void
value_krc_file_free_value (GValue* value)
{
#line 33 "krcfile.vala"
	if (value->data[0].v_pointer) {
#line 33 "krcfile.vala"
		krc_file_unref (value->data[0].v_pointer);
#line 3671 "krcfile.c"
	}
}

static void
value_krc_file_copy_value (const GValue* src_value,
                           GValue* dest_value)
{
#line 33 "krcfile.vala"
	if (src_value->data[0].v_pointer) {
#line 33 "krcfile.vala"
		dest_value->data[0].v_pointer = krc_file_ref (src_value->data[0].v_pointer);
#line 3683 "krcfile.c"
	} else {
#line 33 "krcfile.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3687 "krcfile.c"
	}
}

static gpointer
value_krc_file_peek_pointer (const GValue* value)
{
#line 33 "krcfile.vala"
	return value->data[0].v_pointer;
#line 3696 "krcfile.c"
}

static gchar*
value_krc_file_collect_value (GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
#line 33 "krcfile.vala"
	if (collect_values[0].v_pointer) {
#line 3707 "krcfile.c"
		KRcFile * object;
		object = collect_values[0].v_pointer;
#line 33 "krcfile.vala"
		if (object->parent_instance.g_class == NULL) {
#line 33 "krcfile.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3714 "krcfile.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 33 "krcfile.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3718 "krcfile.c"
		}
#line 33 "krcfile.vala"
		value->data[0].v_pointer = krc_file_ref (object);
#line 3722 "krcfile.c"
	} else {
#line 33 "krcfile.vala"
		value->data[0].v_pointer = NULL;
#line 3726 "krcfile.c"
	}
#line 33 "krcfile.vala"
	return NULL;
#line 3730 "krcfile.c"
}

static gchar*
value_krc_file_lcopy_value (const GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
	KRcFile ** object_p;
	object_p = collect_values[0].v_pointer;
#line 33 "krcfile.vala"
	if (!object_p) {
#line 33 "krcfile.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3745 "krcfile.c"
	}
#line 33 "krcfile.vala"
	if (!value->data[0].v_pointer) {
#line 33 "krcfile.vala"
		*object_p = NULL;
#line 3751 "krcfile.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 33 "krcfile.vala"
		*object_p = value->data[0].v_pointer;
#line 3755 "krcfile.c"
	} else {
#line 33 "krcfile.vala"
		*object_p = krc_file_ref (value->data[0].v_pointer);
#line 3759 "krcfile.c"
	}
#line 33 "krcfile.vala"
	return NULL;
#line 3763 "krcfile.c"
}

GParamSpec*
param_spec_krc_file (const gchar* name,
                     const gchar* nick,
                     const gchar* blurb,
                     GType object_type,
                     GParamFlags flags)
{
	ParamSpecKRcFile* spec;
#line 33 "krcfile.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_KRC_FILE), NULL);
#line 33 "krcfile.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 33 "krcfile.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 33 "krcfile.vala"
	return G_PARAM_SPEC (spec);
#line 3782 "krcfile.c"
}

gpointer
value_get_krc_file (const GValue* value)
{
#line 33 "krcfile.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KRC_FILE), NULL);
#line 33 "krcfile.vala"
	return value->data[0].v_pointer;
#line 3792 "krcfile.c"
}

void
value_set_krc_file (GValue* value,
                    gpointer v_object)
{
	KRcFile * old;
#line 33 "krcfile.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KRC_FILE));
#line 33 "krcfile.vala"
	old = value->data[0].v_pointer;
#line 33 "krcfile.vala"
	if (v_object) {
#line 33 "krcfile.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KRC_FILE));
#line 33 "krcfile.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "krcfile.vala"
		value->data[0].v_pointer = v_object;
#line 33 "krcfile.vala"
		krc_file_ref (value->data[0].v_pointer);
#line 3814 "krcfile.c"
	} else {
#line 33 "krcfile.vala"
		value->data[0].v_pointer = NULL;
#line 3818 "krcfile.c"
	}
#line 33 "krcfile.vala"
	if (old) {
#line 33 "krcfile.vala"
		krc_file_unref (old);
#line 3824 "krcfile.c"
	}
}

void
value_take_krc_file (GValue* value,
                     gpointer v_object)
{
	KRcFile * old;
#line 33 "krcfile.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KRC_FILE));
#line 33 "krcfile.vala"
	old = value->data[0].v_pointer;
#line 33 "krcfile.vala"
	if (v_object) {
#line 33 "krcfile.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KRC_FILE));
#line 33 "krcfile.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "krcfile.vala"
		value->data[0].v_pointer = v_object;
#line 3845 "krcfile.c"
	} else {
#line 33 "krcfile.vala"
		value->data[0].v_pointer = NULL;
#line 3849 "krcfile.c"
	}
#line 33 "krcfile.vala"
	if (old) {
#line 33 "krcfile.vala"
		krc_file_unref (old);
#line 3855 "krcfile.c"
	}
}

static void
krc_file_class_init (KRcFileClass * klass,
                     gpointer klass_data)
{
#line 33 "krcfile.vala"
	krc_file_parent_class = g_type_class_peek_parent (klass);
#line 33 "krcfile.vala"
	((KRcFileClass *) klass)->finalize = krc_file_finalize;
#line 33 "krcfile.vala"
	g_type_class_adjust_private_offset (klass, &KRcFile_private_offset);
#line 3869 "krcfile.c"
}

static void
krc_file_instance_init (KRcFile * self,
                        gpointer klass)
{
#line 33 "krcfile.vala"
	self->priv = krc_file_get_instance_private (self);
#line 33 "krcfile.vala"
	self->ref_count = 1;
#line 3880 "krcfile.c"
}

static void
krc_file_finalize (KRcFile * obj)
{
	KRcFile * self;
#line 33 "krcfile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KRC_FILE, KRcFile);
#line 33 "krcfile.vala"
	g_signal_handlers_destroy (self);
#line 36 "krcfile.vala"
	(self->priv->m_groups == NULL) ? NULL : (self->priv->m_groups = (_g_list_free__krc_file_group_free0_ (self->priv->m_groups), NULL));
#line 3893 "krcfile.c"
}

static GType
krc_file_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_krc_file_init, value_krc_file_free_value, value_krc_file_copy_value, value_krc_file_peek_pointer, "p", value_krc_file_collect_value, "p", value_krc_file_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (KRcFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) krc_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KRcFile), 0, (GInstanceInitFunc) krc_file_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType krc_file_type_id;
	krc_file_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KRcFile", &g_define_type_info, &g_define_type_fundamental_info, 0);
	KRcFile_private_offset = g_type_add_instance_private (krc_file_type_id, sizeof (KRcFilePrivate));
	return krc_file_type_id;
}

GType
krc_file_get_type (void)
{
	static volatile gsize krc_file_type_id__once = 0;
	if (g_once_init_enter (&krc_file_type_id__once)) {
		GType krc_file_type_id;
		krc_file_type_id = krc_file_get_type_once ();
		g_once_init_leave (&krc_file_type_id__once, krc_file_type_id);
	}
	return krc_file_type_id__once;
}

gpointer
krc_file_ref (gpointer instance)
{
	KRcFile * self;
	self = instance;
#line 33 "krcfile.vala"
	g_atomic_int_inc (&self->ref_count);
#line 33 "krcfile.vala"
	return instance;
#line 3929 "krcfile.c"
}

void
krc_file_unref (gpointer instance)
{
	KRcFile * self;
	self = instance;
#line 33 "krcfile.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 33 "krcfile.vala"
		KRC_FILE_GET_CLASS (self)->finalize (self);
#line 33 "krcfile.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3943 "krcfile.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

